/************************************************************************/
/* TinyTalk word wrapping.						 */
/* */
/* Version 1.0 [ 1/24/90] : Initial implementation by ABR.		 */
/* */
/************************************************************************/

#include "TinyMUD_copyright.h"
#include "client.h"
#include <stdio.h>

extern char    *rindex();

static int      current_wrap_column;
static int      default_wrap_column;

print_with_wrap(s)
	char           *s;
{
	hugestr         temp;
	char           *place;
	int             loc;

	if (current_wrap_column == -1)
		current_wrap_column = default_wrap_column;

	if ((current_wrap_column == 0) || strlen(s) < current_wrap_column) {
		puts(s);	/* No wrap. */
		return;
	}
	strcpy(temp, s);
	do {
		temp[current_wrap_column] = '\0';
		place = rindex(temp, ' ');
		if (place == NULL) {	/* Can't wrap, give up */
			puts(temp);
			loc = current_wrap_column;
		} else {
			*place = '\0';	/* Terminate string */
			puts(temp);	/* and output it. */
			loc = place - temp + 1;
		}
		strcpy(temp, s + loc);	/* Rest of string. */
		strcpy(s, temp);/* Should strip double spaces? */
	} while (strlen(s) >= current_wrap_column);

	if (strlen(s) != 0) {
		puts(s);
	}
}

enable_wrap(column)		/* Doesn't just set column, because */
	int             column;	/* might not have initted keyboard. */
{
	current_wrap_column = ((column == 0) ? -1 : column);
}

disable_wrap()
{
	current_wrap_column = 0;
}

set_default_wrap(column)
	int             column;
{
	default_wrap_column = column;
}
