/*
** Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
** smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
** Restrictions in GB_copyright.h.
**
**  capture.c -- capture a ship on the ground
**
*/

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "ships.h"
#include "races.h"
#include "buffers.h"
#include <signal.h>
#include <math.h>
#include <signal.h>

int capture_sectdata,capture_shdata,capture_pdata, capture_racedata;

extern int Defensedata[];


capture(Playernum,APcount, argn,args)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
shiptype *ship;
planettype *p;
sectortype *sect;
racetype *alien;
boolean Land=0,Dock=0,cont,planetmod=0,sectmod=0;
int boarders,olddpopn,oldapopn,oldowner,shipdam,booby,pris,
	numdest=0,shipno,x= -1,y= -1,i,mask, casualties, casualties2;
float astrength,dstrength;

capture_sectdata = capture_shdata = capture_pdata = NEUTRAL_FD;

sscanf(args[1]+(args[1][0]=='#'), "%d",&shipno);

  openshdata(&capture_shdata);
  if (!getship(capture_shdata, &ship, shipno)) {
	sprintf(buf,"Ship doesn't exist.\n");
	notify(Playernum, buf);
close(capture_shdata);
	return;
  }
close(capture_shdata);

  if (!ship->is_alive || !(ship->is_docked && ship->whatdest==LEVEL_PLAN) ) {
	sprintf(buf,"%s #%d is not landed on a planet.\n",
		Shipnames[ship->type], shipno);
	notify(Playernum, buf);
	return;
  }

  if (ship->owner==Playernum) {
	sprintf(buf,"That's your own ship.\n");
	notify(Playernum, buf);
	return;
  }


  if (!enufAP(Playernum,Stars[ship->storbits]->AP[Playernum-1], APcount))
	return;


free(Race);
openracedata(&capture_racedata);
getrace(capture_racedata, &Race, Playernum);
close_file(capture_racedata);

x = (int)ship->xpos;
y = (int)ship->ypos;

     openpdata(&capture_pdata);
     getplanet(capture_pdata, &p, Stars[ship->storbits]->planetpos[ship->pnumorbits]);
     close_file(capture_pdata);


     opensectdata(&capture_sectdata);
     getsector(capture_sectdata,&sect,
	p->sectormappos+(y*p->Maxx+x)*sizeof(sectortype));

     if (sect->owner!=Playernum) {
	sprintf(buf,"You don't own the sector where the ship is landed.\n");
	notify(Playernum, buf);
	return;
     }

	openracedata(&capture_racedata);
     getrace(capture_racedata, &alien, ship->owner);
	close_file(capture_racedata);

	boarders = atoi(args[2]);

		if (boarders > MIN(sect->popn, Max_crew(ship)) || boarders <= 0) {
			sprintf(buf,"Illegal number of boarders (max can be %d).\n",
				MIN(sect->popn, Max_crew(ship)));
			notify(Playernum, buf);
			return;
		}


     if (isset(Race->allied, ship->owner))
	{
	sprintf(buf,"Boarding the ship of your ally, %s\n", alien->name);
	notify(Playernum, buf);
	}

     oldapopn = boarders;
     olddpopn = ship->popn;
     oldowner = ship->owner;
	shipdam = 0;
	casualties = 0;
	casualties2 = 0;

	if(olddpopn || !Max_crew(ship)) {

     sprintf(buf,"Attack strength: %.2f     Defense strength: %f\n",
		   astrength = 0.1 * boarders * log10(Race->fighters
			* (Race->tech + 1.0) * (Race->likes[sect->des] + 1.0)
			* (sect->is_wasted ? 0 : Defensedata[sect->des] + 10)),

		    dstrength = 0.1* ship->popn * log10(alien->fighters
			* (alien->tech + 1.0) * 
	 		(Armor(ship)+1) + 10)
	     * .01 * (100 - ship->damage));

	notify(Playernum, buf);
 
	sect->popn -= boarders;
	booby = 0;

if(astrength > 0.0) {
     	casualties = MIN(boarders, int_rand(0, (int)((float)boarders * dstrength / astrength)));
	if(casualties > boarders) casualties = boarders; /* shouldnt happen, but it does sometimes !*/
	boarders -= casualties;
	}

if(dstrength > 0.0) {
	casualties2 = MIN(olddpopn, int_rand(0, (int)((float)olddpopn * astrength / dstrength)));
	if(casualties2 > olddpopn) casualties2 = olddpopn;
	/* ditto */

	ship->popn -= casualties2;
	ship->mass -= casualties2 * alien->mass;
			/* (their mass) */

     shipdam = int_rand(0,round_rand(25. * astrength/dstrength));
		 /* check for boobytrapping */
	ship->damage = MIN(100, ship->damage+shipdam);

	if(ship->damage >= 100)
		{
			ship->popn = 0;
			kill_ship(ship);
			}			
	}
}

		   if ((ship->popn == 0)  && ship->is_alive) {
				/* we got 'em */
			ship->owner = Playernum;
			ship->popn = boarders;
			ship->mass += boarders * Race->mass;	/* our mass */
		   } else {		/* retreat */
			sect->popn += boarders;
		   }

	if(sect->popn == 0)
		sect->owner = 0;

		sprintf(buf,"BULLETIN from %s/%s!!\n",
			Stars[ship->storbits]->name,Stars[ship->storbits]->pnames[ship->pnumorbits]);
		notify(oldowner, telegram_buf);
		sprintf(buf,"You are being attacked by%s Player #%d (%s)!!!\n",
			(isset(alien->allied,Playernum) ? " your ally" :
				(isset(alien->atwar,Playernum) ? " your enemy" : " neutral")),
				Playernum,Race->name);
		notify(oldowner, buf);
		sprintf(buf,"%s #%d ASSAULTED at sector %d,%d [owner %d] !\n",
			Shipnames[ship->type], shipno, x, y, sect->owner);
		notify(oldowner, buf);
		sprintf(buf,"Your damage: %d%% (now %d%%)\n", shipdam, ship->damage);
		notify(oldowner, buf);
		sprintf(buf,"Damage inflicted:  Them: %d%% (now %d%%)\n", shipdam,ship->damage);
		notify(Playernum, buf);
	if(!ship->is_alive) {
  		sprintf(buf,"              YOUR SHIP WAS DESTROYED!!!\n");
		notify(oldowner, buf);
  		sprintf(buf,"              Their ship DESTROYED!!!\n");
		notify(Playernum, buf);
	}

			if (ship->owner==Playernum) {
				sprintf(buf,"%s CAPTURED!\n",Shipnames[ship->type]);
					notify(oldowner, buf);
				sprintf(buf,"VICTORY! The ship is yours!\n");
					notify(Playernum, buf);
				if (astrength/dstrength > 5.0) {
				   pris=astrength/dstrength;
				   pris=MIN(pris,olddpopn);
				   if (Race->captured_prisoners[oldowner-1]<100)
				     Race->captured_prisoners[oldowner-1]++;
				   sprintf(buf,"1 prisoner captured!\n");
					notify(Playernum, buf);
				   sprintf(buf,"1 prisoner captured!\n");
					notify(oldowner, buf);
				if (boarders)
					{
				  sprintf(buf,"%d boarders move in.\n", boarders);
				  	notify(Playernum, buf);
					}
				}
			} else if(ship->popn) {
				sprintf(buf,"You fought them off!\n");
					notify(oldowner, buf);
				sprintf(buf,"The boarding was repulsed; try again.\n");
					notify(Playernum, buf);
			}

		if (ship->is_alive) {
			if (sect->popn + boarders == 0) {
				sprintf(buf,"You killed all the aliens in this sector!\n");
					notify(oldowner, buf);
			} else sprintf(buf," ");
			if (boarders==0) {
				sprintf(buf,"Oh no! They killed your party to the last man!\n");
					notify(Playernum, buf);
			}
		} else {
			sprintf(buf,"Your ship was weakened too much!\n");
					notify(oldowner, buf);
			sprintf(buf,"The assault weakened their ship too much!\n");
					notify(Playernum, buf);
		}
		sprintf(buf,"Casualties: Yours: %d, Theirs: %d\n", casualties2, casualties);
				notify(oldowner, buf);
		sprintf(buf,"Casualties: Yours: %d, Theirs: %d\n", casualties, casualties2);
				notify(Playernum, buf);
	
     openshdata(&capture_shdata);
     putship(capture_shdata, ship, shipno);
     close_file(capture_shdata);

     putsector(capture_sectdata,sect,p->sectormappos+(y*p->Maxx+x)*sizeof(sectortype));
     close_file(capture_sectdata);

     deductAPs(Playernum, APcount, ship->storbits, 0);

openracedata(&capture_racedata);
    putrace(capture_racedata, Race);
close_file(capture_racedata);


     free(ship);
     free(sect);
     free(alien);

}

