/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 * enrol.c -- initializes to owner one sector and planet. 
 */

#include "GB_copyright.h"
#include <stdio.h>
#include <signal.h>
#include <strings.h>
#include <curses.h>
#include <errno.h>
#define EXTERN
#include "vars.h"
#include "ships.h"
#include "shipdata.h"
#include "races.h"
#include "buffers.h"
extern int errno;
char desshow();

struct stype {
	char here;
	char x,y;
	int count;
};
#define RACIAL_TYPES 10

/* racial types (10 racial types ) */
int Thing[RACIAL_TYPES] = {1, 1, 1, 0, 0, 0, 0, 0, 0, 0};
float db_Mass[RACIAL_TYPES] = {1.0, 1.5, 2.0, 1.25, 1.25, 1.25, 1.25, 1.25, 1.25, 1.25};
float db_Birthrate[RACIAL_TYPES] = {0.8, 0.8, 0.9, 0.4, 0.4, 0.4, 0.4, 0.5, 0.5, 0.5};
int db_Fighters[RACIAL_TYPES] = {6, 7, 8, 2, 3, 3, 4, 4, 5, 5};
int db_Intelligence[RACIAL_TYPES] = {80, 70, 60, 190, 180, 170, 160, 150, 140, 130};
float db_Adventurism[RACIAL_TYPES] = {0.89, 0.89, 0.89, .5, .5, .5, .6, .6, .7, .8};
int Min_Sexes[RACIAL_TYPES] = {1, 1, 1, 2, 2, 2, 2, 2, 2, 2};
int Max_Sexes[RACIAL_TYPES] = {1, 1, 1, 2, 2, 4, 4, 4, 4, 4};
float db_Metabolism[RACIAL_TYPES] = {1.3, 1.3, 1.3, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0};

#define RMass(x) (db_Mass[(x)] + .01*(float)int_rand(-25, 25))
#define Birthrate(x) (db_Birthrate[(x)] + .01*(float)int_rand(-10, 10))
#define Fighters(x) (db_Fighters[(x)] + int_rand(-1, 1))
#define Intelligence(x) (db_Intelligence[(x)] + int_rand(-10, 10))
#define Adventurism(x) (db_Adventurism[(x)] + 0.01*(float)int_rand(-10,10))
#define Sexes(x) (int_rand(Min_Sexes[(x)], int_rand(Min_Sexes[(x)], Max_Sexes[(x)])))
#define Metabolism(x) (db_Metabolism[(x)] + .01*(float)int_rand(-25, 25))

/* compatibility schematic for sectors.  Note that plated sectors are
   compatible with everything.  */
float Likes[DES_PLATED+1][DES_PLATED+1] = {
               /* DES_SEA     DES_LAND   DES_MOUNT  DES_GAS DES_ICE DES_PLATED*/
/*DES_SEA  */      1.0,        0.0,        0.0,       0.5,     0.3,     1.0,
/*DES_LAND */      0.0,        1.0,        0.6,       0.05,    0.4,     1.0,
/*DES_MOUNT*/      0.0,        0.6,        1.0,       0.05,    0.5,     1.0,
/*DES_GAS  */      0.5,        0.05,       0.05,      1.0,     0.0,     1.0,
/*DES_ICE  */      0.2,        0.5,        0.7,       0.0,     1.0,     1.0,
/*DES_PLATED*/     1.0,        1.0,        1.0,       1.0,     1.0,     1.0
};

char *Desnames[] = {
	"ocean",
	"land",
	"mountainous",
	"gaseous",
	"ice",
	"plated",
	"error in des type!",	/* (illegal values) */
	"err in des type!"
};

main()
{
int x,y, or;
int pnum,star=0,found=0,check,vacant,count,i,j,enroll_pdata, Playernum,
	ifd, enroll_sectdata, enroll_stardata,enroll_shdata, enroll_racedata, mask,ppref = -1;
int maim_stardata, s, idx;
char str[100], c;
char loginname[MAXCOMMSTRSIZE];
sectortype *sect;
struct stype secttypes[DES_PLATED+1];
planettype *planet;
boolean not_found[TYPE_GASGIANT+1];
FILE *fd;

 srandom(getpid());
/* compute powers of 2 for bit operations */
	Two[0]=1;
	for(i=1;i<32;i++)
		Two[i]=2*Two[i-1];

 if ( (Playernum=Numraces()+1) >= MAXPLAYERS) {
	printf("There are already %d players; No more allowed.\n",MAXPLAYERS);
	exit(-1);
 }

/*printf("Enter racial type to be created (1-%d):", RACIAL_TYPES);
scanf("%d", &idx);
getchr();
idx -= 1;
*/
idx = int_rand(3,10);

if(idx < 0 || idx > RACIAL_TYPES-1) {
	printf("Bad racial index.\n");
	exit(1);
	}


	openstardata(&maim_stardata);
	  getsdata(maim_stardata,&Sdata);

	for (s=0; s<Sdata.numstars; s++)
		getstar(maim_stardata,&(Stars[s]),s);
	close_file(maim_stardata);


 printf("There is still space for player %d.\n", Playernum);
   /* look at enroll screen */
/* sprintf(str, "%s %s", PAGER, ENROLL_FL);
 system(str);
*/

printf("Enter the password for this race:");
scanf("%s", loginname);  
getchr();

 /* look at enroll screen */
/*
 sprintf(str, "%s %s", PAGER, ENROLL_FL);
 system(str);
*/


 bzero((char *)not_found, sizeof(not_found));
 do {
/*
    printf("\nLive on what type planet:(e)arth, (g)asgiant, (a)irless, (i)ce, (w)ater? ");
    	c=getchr();
	getchr();
   
 switch (c) {
    	case 'w': ppref = TYPE_WATER;
		break;
	case 'e': ppref = TYPE_EARTH;
		 break;
	case 'a': ppref = TYPE_AIRLESS;
		 break;
	case 'g': ppref = TYPE_GASGIANT;
		 break;
	case 'i': ppref = TYPE_ICEBALL;
		 break;
	default: printf("Oh well.\n");
		 exit(-1);
		 break;
    }
*/

	switch(int_rand(1,4)) {
		case 1 : ppref = TYPE_EARTH; break;
		case 2 : ppref = TYPE_AIRLESS; break;
		case 3 : ppref = TYPE_ICEBALL; break;
		case 4 : ppref = TYPE_WATER; break;
	default: printf("Oh well.\n");
		 exit(-1);
		 break;
		}

	printf("Looking for type %d planet...\n", ppref);

	/* find first planet of right type */
         count = 0;
	found = 0;

  for (star=0; star<Sdata.numstars && !found && count < 100; ) {

	check = 1;
	  /* skip over uninhabited stars */
	if (Stars[star]->inhabited)
			check = 0;

	  /* look for unihabited planets */
	 if (check) {
	  pnum = 0;
	  while (!found && pnum<Stars[star]->numplanets) {
printf("%s %d %d\n", Stars[star]->name, star, Stars[star]->planetpos[pnum]);

	    openpdata(&enroll_pdata);
	    getplanet(enroll_pdata,&planet,Stars[star]->planetpos[pnum]);

	    if (planet->type==ppref) {
	    	vacant = 1;
	    	for (i=1; i<=Playernum; i++ )
			if (planet->info[i-1].numsectsowned)
				vacant = 0;
		if (vacant && planet->conditions[RTEMP] >= -50 && planet->conditions[RTEMP] <= 50)
			{
			Dir[Playernum-1].snum = star;
			Dir[Playernum-1].pnum = pnum;
			found = 1;
			}
 	    }
	    if (!found) {
		close_file(enroll_pdata);
		free(planet);
		pnum++;
	    }
	 }
}

 if (!found) {
     count++;
     star = int_rand(0,Sdata.numstars-1);
   } 

}

   if (!found) {
   	printf("planet type not found in any free systems.\n");
	not_found[ppref] = 1;
	for (found=1,i=TYPE_EARTH; i<=TYPE_WATER; i++)
		found &= not_found[i];
	if (found) {
	     printf("Looks like there aren't any free planets left.  bye..\n");
	     endwin();
	     exit(-1);
	} else
	     printf("  Try a different one...\n");
	found = 0;
   }

 } while (!found);

 Race = Malloc(racetype);
 Bzero(*Race);

 printf("\n\tGod status(y/n)\?");
	c=getchr();
	getchr();

 if (c=='y') 
	Race->God=1;
else 
	Race->God=0;


 printf("\n\nEnter a name for your race:");
 dots(RNAMESIZE);
 scanf("%s",str); 
 getchr();

 strncpy(Race->name, str, RNAMESIZE-1);

 Race->homelevel = Race->deflevel = LEVEL_PLAN;
 Race->homesystem = Race->defsystem = star;
 Race->homeplanetnum = Race->defplanetnum = pnum;

	/* make conditions preferred by your people set to (more or less) 
	   those of the planet : higher the concentration of gas, the higher
	   percentage difference between planet and race (commented out) */
 for (j=0; j<=OTHER; j++)
	Race->conditions[j] = planet->conditions[j]; 
	/*+ int_rand( round_rand(-planet->conditions[j]*2.0), round_rand(planet->conditions[j]*2.0) )*/


 for (i=0; i<MAXPLAYERS; i++) {
   /* messages from autoreport, player #1 are decodable */
	if ((i==Playernum || Playernum==1) || Race->God)
		Race->translate[i-1] = 100;	/* you can talk to own race */
	else
		Race->translate[i-1] = 1;
 }

/* assign racial characteristics */

	Race->tech = 0;
	Race->overbirthrate = float_rand() * 0.01;
		/* your race is like "the Thing" */
		Race->Thing = Thing[idx];
		Race->mass = RMass(idx);
		Race->birthrate = Birthrate(idx);
		Race->fighters = Fighters(idx);
		Race->IQ = Intelligence(idx);
		Race->adventurism = Adventurism(idx);
		Race->number_sexes = Sexes(idx);
		Race->metabolism = Metabolism(idx);

	printf("%s\n", Race->Thing ? "MESOMORPHIC" : "");
	printf("       Birthrate: %.3f\n",Race->birthrate);
	printf("Fighting ability: %d\n",Race->fighters);
	printf("              IQ: %d\n",Race->IQ);
	printf("      Metabolism: %.2f\n",Race->metabolism);
	printf("     Adventurism: %.2f\n",Race->adventurism);
	printf("            Mass: %.2f\n",Race->mass);
	printf(" Number of sexes: %d (min req'd for colonization)\n",Race->number_sexes);

 bzero((char *)secttypes, sizeof(secttypes));

 opensectdata(&enroll_sectdata);
 getsmap(enroll_sectdata,Smap,planet);

 printf("\nChoose a primary sector preference. This race will prefer to live\non this type of sector.\n");

 PermuteSects(planet);
 Getxysect(planet, 0, 0, 1);
 while (Getxysect(planet,&x,&y,0)) {
	secttypes[Sector(*planet,x,y).des].count++;
	if (!secttypes[Sector(*planet,x,y).des].here)
	  if ( !(planet->type==TYPE_GASGIANT && y<planet->Maxy-2 && y>0) ) {
		secttypes[Sector(*planet,x,y).des].here = 1;
		secttypes[Sector(*planet,x,y).des].x = x;
		secttypes[Sector(*planet,x,y).des].y = y;
	  }
 }

 Playernum = 1;
 planet->is_explored = 1;
 for (i=DES_SEA; i<=DES_PLATED; i++)
	if (secttypes[i].here) {
		Sector(*planet,secttypes[i].x,secttypes[i].y).is_wasted = 0;
		printf("(%2d): %c  (%s, %d sectors)\n", i,
		     desshow(planet, secttypes[i].x,secttypes[i].y),
		     Desnames[i], secttypes[i].count);
	}
 planet->is_explored = 0;

 found = 0;
do {
 printf("\nchoice (enter the number): ");
scanf("%d", &i);
	getchr();
   if (i<DES_SEA || i>DES_PLATED || !secttypes[i].here) {
	printf("There are none of that type here..\n");
   } else
	found = 1;
 } while (!found);

 sect = &Sector(*planet,secttypes[i].x,secttypes[i].y);
 Race->likesbest = i;
 for (j=DES_SEA; j<=DES_PLATED; j++)
	Race->likes[j] = Likes[i][j];

 Playernum = Race->Playernum = Numraces() + 1;

 mask = sigblock(SIGBLOCKS);

	/* build a capitol ship to run the government */
 { 
	shiptype s; 
	int shipno;

	Bzero(s);
	openshdata(&enroll_shdata);
	shipno = Numships(enroll_shdata) + 1;
printf("government ship %d\n", shipno);
	Race->Gov_ship = shipno;
	planet->ships = shipno;
	s.nextship = 0;

	s.type = OTYPE_GOV;
	s.xpos = (float)secttypes[i].x;
	s.ypos = (float)secttypes[i].y;

	s.speed = 0;
	s.owner = Playernum;

	s.tech = 100.0;

	s.build_type = OTYPE_GOV;
	s.armor = Shipdata[OTYPE_GOV][ABIL_ARMOR];
	s.guns = Shipdata[OTYPE_GOV][ABIL_GUNS];
	s.size = Shipdata[OTYPE_GOV][ABIL_TARGET];
	s.max_crew = Shipdata[OTYPE_GOV][ABIL_MAXCREW];
	s.max_destruct = Shipdata[OTYPE_GOV][ABIL_DESTCAP];
	s.max_resource = Shipdata[OTYPE_GOV][ABIL_CARGO];
	s.max_fuel = Shipdata[OTYPE_GOV][ABIL_FUELCAP];
	s.max_speed = Shipdata[OTYPE_GOV][ABIL_SPEED];
	s.build_cost = Shipdata[OTYPE_GOV][ABIL_COST];
	s.base_mass = MAX(1.0, (float)s.armor + (float)s.size/10.0 + (float)s.guns/10.0);
	sprintf(s.class, "Standard");



	s.fuel = 0.0;
	s.popn = Shipdata[s.type][ABIL_MAXCREW];
	s.mass = s.base_mass + Shipdata[s.type][ABIL_MAXCREW]*Race->mass;
	s.destruct = s.resource = 0;

	s.is_alive = 1;
 	s.active = 1;
 	s.protect.self = 1;

	s.is_docked = 1;
		/* docked on the planet */
	s.whatorbits = LEVEL_PLAN;
	s.whatdest = LEVEL_PLAN;
	s.deststar = Dir[Playernum-1].snum;
	s.destpnum = Dir[Playernum-1].pnum;
	s.storbits = Dir[Playernum-1].snum;
	s.pnumorbits = Dir[Playernum-1].pnum;
	s.rad = 0;
	s.damage = 0;	/*Shipdata[s.type][ABIL_DAMAGE];*/
		/* (first capitol is 100% efficient */

	s.object.number = 0;
	s.object.number2 = 0;
	s.object.number3 = 0;
	s.object.number4 = 0;

	s.on = 1;

	s.name[0] = '\0';

	putship(enroll_shdata, &s, shipno);
	close_file(enroll_shdata);

 }

openracedata(&enroll_racedata);
 putrace(enroll_racedata, Race);
close_file(enroll_racedata);

 planet->info[Playernum-1].numsectsowned = 1;
 planet->is_explored = 0;
 planet->info[Playernum-1].explored = 1;
 /*planet->info[Playernum-1].autorep = 1;*/


 sect->owner = Playernum;
 sect->popn = planet->popn = Race->number_sexes;
 sect->fert = 100;
 sect->eff = 10;
 planet->maxpopn = maxsupport(Race, sect, 100.0,0) 
		* planet->Maxx * planet->Maxy / 2;
			/* (approximate) */

 putsector(enroll_sectdata,sect,planet->sectormappos+(secttypes[i].y*planet->Maxx+secttypes[i].x)*sizeof(sectortype));
 close_file(enroll_sectdata);

 putplanet(enroll_pdata,planet,Stars[star]->planetpos[pnum]);
 close_file(enroll_pdata);

	/* make star explored and stuff */
 openstardata(&enroll_stardata);
  getstar(enroll_stardata,&Stars[star],star);
   setbit(Stars[star]->explored,Playernum);
   setbit(Stars[star]->inhabited,Playernum);
   Stars[star]->AP[Playernum-1] = 5;
  putstar(enroll_stardata,Stars[star],star);
 close_file(enroll_stardata);

 fd = fopen(PLAYERDATAFL,"a");
 fprintf(fd,"%s\n",loginname );
 fclose(fd);

 sigsetmask(mask);

  printf("\nYou are player %d.\n\n",Playernum);
 printf("Your race has been created on sector %d,%d on\n",
				secttypes[i].x,secttypes[i].y);
 printf("Planet %d of star %s.\n\n",pnum+1,Stars[star]->name);

}

char desshow(p,x,y) /* copied from map.c */
reg planettype *p;
reg int x,y;
{
reg sectortype *s;

s = &Sector(*p,x,y);

   if (s->is_wasted) 
	return CHAR_WASTELAND;
   switch (s->des) {
     	case DES_SEA: return CHAR_SEA;
     	case DES_LAND: return CHAR_LAND;
     	case DES_MOUNT: return CHAR_MOUNT;
     	case DES_GAS: return CHAR_GAS;
     	case DES_PLATED: return CHAR_PLATED;
     	case DES_ICE: return CHAR_ICE;
     	default: return('!');
   }


}

void notify(who, msg)
int who;
char *msg;
{
/* this is a dummy routine */
}


