/*
** Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
** smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
** Restrictions in GB_copyright.h.
**  enslave.c -- ENSLAVE the planet below.
*/

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "ships.h"
#include "races.h"
#include "buffers.h"
#include <signal.h>

int enslave_shdata,enslave_pdata, enslave_racedata;

enslave(Playernum, APcount, argn,args)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
shiptype *s, *s2;
planettype *p;
int sh,shipno,i,mask,aliens=0,def=0,attack=0;
double Dist;

enslave_shdata = enslave_pdata = NEUTRAL_FD;

sscanf(args[1]+(args[1][0]=='#'), "%d",&shipno);

  openshdata(&enslave_shdata);
  if (!getship(enslave_shdata, &s, shipno)) {
      close_file(enslave_shdata);
	return;
  }
  close_file(enslave_shdata);

  if (s->owner!=Playernum) {
	DontOwnErr(Playernum,shipno);
	return; 
 }

  if (testship(Playernum,s, shipno)) {
	return;
	}

  if (s->type != STYPE_ASS) {
	sprintf(buf,"This ship is not an %s.\n", Shipnames[STYPE_ASS]);
		notify(Playernum, buf);
	return;
  }
  if (s->whatorbits!=LEVEL_PLAN) {
	sprintf(buf,"%s #%d doesn't orbit a planet.\n", Shipnames[s->type],shipno);
		notify(Playernum, buf);
	return;
  }

  if (!enufAP(Playernum,Stars[s->storbits]->AP[Playernum-1], APcount)) { 
	return;
	}

free(Race);
openracedata(&enslave_racedata);
getrace(enslave_racedata, &Race, Playernum); 
close_file(enslave_racedata);

 openpdata(&enslave_pdata);
  getplanet(enslave_pdata,&p,Stars[s->storbits]->planetpos[s->pnumorbits]);
close_file(enslave_pdata);
  if (p->info[Playernum-1].numsectsowned==0) {
	sprintf(buf,"You don't have a garrison on the planet.\n");
		notify(Playernum, buf);
	return;
  }

	/* add up forces attacking, defending */
  for (attack=aliens=def=0,i=1; i<MAXPLAYERS; i++) {
	if (p->info[i-1].numsectsowned && i!=Playernum) {
		aliens = 1;
		def += p->info[i-1].destruct;
	}
  }

  if (!aliens) {
	sprintf(buf,"There is no one else on this planet to enslave!\n");
		notify(Playernum, buf);
	return;
  }

  sh = p->ships;
  openshdata(&enslave_shdata);
  while (sh) {
	(void)getship(enslave_shdata, &s2, sh);
	if (p->info[s2->owner].numsectsowned && s2->owner!=Playernum)
		def += s2->destruct;
	else if (s2->owner==Playernum)
		attack += s2->destruct;
	sh = s2->nextship;
	free(s2);
  }
  close_file(enslave_shdata);

  deductAPs(Playernum,APcount, s->storbits, 0);

  sprintf(buf,"\nFor successful enslavement this ship and the other ships here\n");
		notify(Playernum, buf);
  sprintf(buf,"that are yours must have a weapons\n");
		notify(Playernum, buf);
  sprintf(buf,"capacity greater than twice that the enemy can muster, including\n");
		notify(Playernum, buf);
  sprintf(buf,"the planet and all ships orbiting it.\n");
		notify(Playernum, buf);
  sprintf(buf,"\nTotal forces bearing on %s:   %d\n", prin_ship_orbits(s), attack);
		notify(Playernum, buf);

    sprintf(telegram_buf,"ALERT!!!\n\nPlanet /%s/%s ", 
		Stars[s->storbits]->name,
		Stars[s->storbits]->pnames[s->pnumorbits]);
 
  if (def <= 2 * attack) {

	p->slaved_to = Playernum;
	openpdata(&enslave_pdata);
  	putplanet(enslave_pdata,p,Stars[s->storbits]->planetpos[s->pnumorbits]);
  	close_file(enslave_pdata);

	/* send telegs to anyone there */
	  sprintf(buf,"ENSLAVED by %s #%d!!\n", 
			Shipnames[s->type], shipno);
		str_cat(telegram_buf, buf);
	  sprintf(buf,"All material produced here will be\ndiverted to %s coffers.",
			Race->name);
		str_cat(telegram_buf, buf);

	  sprintf(buf,"\nEnslavement successful.  All material produced here will\n");
		notify(Playernum, buf);
	  sprintf(buf,"be diverted to %s.\n", Race->name);
		notify(Playernum, buf);
	  sprintf(buf,"You must maintain a garrison of 0.1 the population of the\n");
		notify(Playernum, buf);
	  sprintf(buf,"planet (at least %.0f); otherwise there is a 50%% chance that\n", p->popn * 0.01);
		notify(Playernum, buf);
	  sprintf(buf,"enslaved population will revolt.\n");
		notify(Playernum, buf);

  } else {

	  sprintf(buf,"repulsed attempt at enslavement by %s #%d!!\n", 
			Shipnames[s->type], shipno);
		str_cat(telegram_buf, buf);
	  sprintf(buf,"Enslavement repulsed, defense/attack Ratio : %d to %d.\n", def, attack);
		str_cat(telegram_buf, buf);

	  sprintf(buf, "Enslavement repulsed.\n");
		notify(Playernum, buf);
	  sprintf(buf, "You needed more weapons bearing on the planet...\n");
		notify(Playernum, buf);
  }


  for (i=1; i<MAXPLAYERS; i++)
	if (p->info[i-1].numsectsowned && i!=Playernum)
		notify(i, telegram_buf);

  free(p);

}


