/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 *
 *	fix() -- allows manager to edit various stuff.
 *		   -not to be used by players cuz it will get boring fast
 *			note: may not work under machines w/ 
 *				sizeof(int) <> sizeof(float).
 *	list() -- lists all ships for debug purposes.
 */

#define FLOAT 0	/* to tell query what to input for */
#define INT 1
#define CHAR 2
#define SHORT 3
#define LONG 4
#define DOUBLE 5

#define EXTERN
#include "GB_copyright.h"
#include "vars.h"
#include "ships.h"
#include "shipdata.h"
#include "races.h"
#include "buffers.h"
#include <strings.h>
#include <ctype.h>
#include <signal.h>
int fix_stardata,fix_shdata,fix_pdata,fix_sectdata, fix_racedata;
char s[40];

boolean fix_mod;
int Playernum;

main(argc, argv)
int argc;
char *argv[];
{
placetype where;
char ch;
int i;
unsigned long unl;
planettype *p;
sectortype *sect;
shiptype *sh;
int fix_handler();

fix_mod = 0;
fix_stardata = fix_shdata = fix_pdata = fix_sectdata = NEUTRAL_FD;
	/* so closure does not cause wanted files to close (like stdin 
		or stdout) -- should not cause probs most vers. of UNIX */

printf("Enter race number: ");
scanf("%d", &Playernum);

openracedata(&fix_racedata);
free(Race);
getrace(fix_racedata, &Race, Playernum);
close_file(fix_racedata);

if (!strcmp(argv[1], "race", strlen(argv[1]))) {
	query(FLOAT,"tech",&Race->tech,0,0,0,0);
	query(FLOAT,"birthrate",&Race->birthrate,0,0,0,0);
	query(FLOAT,"mass",&Race->mass,0,0,0,0);
	query(FLOAT,"adventurists",&Race->adventurism,0,0,0,0);
	query(FLOAT,"metabolism",&Race->metabolism,0,0,0,0);
	query(FLOAT,"overbirthrate",&Race->overbirthrate,0,0,0,0);

	query(INT, "Playernum",0,&Race->Playernum,0,0,0);
	query(CHAR, "defsystem",0,0,&Race->defsystem,0,0);
	query(CHAR, "defplanetnum",0,0,&Race->defplanetnum,0,0);
	query(CHAR, "fighters",0,0,&Race->fighters,0,0);
	query(CHAR, "IQ",0,0,&Race->IQ,0,0);
	query(CHAR, "# sexes",0,0,&Race->number_sexes,0,0);
	query(CHAR, "likesbest",0,0,&Race->likesbest,0,0);
	  ch = Race->Thing;
	query(CHAR, "Race is like 'The Thing'",0,0,&ch,0,0);
	  Race->Thing = ch;
	    /*float metabolism;*/
	    /*char homelevel,homesystem,homeplanetnum;	/* home place */
	printf("atmospheric cond preferred\n");
	query(CHAR, "Temp",0,0,&Race->conditions[TEMP],0,0);
	query(CHAR, "Rtemp",0,0,&Race->conditions[RTEMP],0,0);
	query(CHAR, "Methane",0,0,&Race->conditions[METHANE],0,0);
	query(CHAR, "Oxygen",0,0,&Race->conditions[OXYGEN],0,0);
	query(CHAR, "CO2",0,0,&Race->conditions[CO2],0,0);
	query(CHAR, "Hydrogen",0,0,&Race->conditions[HYDROGEN],0,0);
	query(CHAR, "Nitrogen",0,0,&Race->conditions[NITROGEN],0,0);
	query(CHAR, "Sulfur",0,0,&Race->conditions[SULFUR],0,0);
	query(CHAR, "Helium",0,0,&Race->conditions[HELIUM],0,0);
	query(CHAR, "Other",0,0,&Race->conditions[OTHER],0,0);
	if (fix_mod){
		printf("saving");
		putrace(Race);}
} else {
  where = Getplace(Playernum,argv[1],0);	/* do not ignore the fact that you've not
					explored the place */
  if (where.err) {
	sprintf(buf,"cs: bad scope.\n");
		notify(Playernum, buf);
	return;
	}
 switch (where.level) {

  case LEVEL_UNIV:
	openstardata(&fix_stardata);
	getsdata(fix_stardata, &Sdata);

	query(CHAR, "ActionPoints",0,0,&Sdata.AP[Playernum-1],0,0);
	query(SHORT, "shiplist start",0,0,0,&Sdata.ships,0);
	/*for (ch=MAXUSHIPS-1; ch>1 && Sdata.shipnums[ch]; ch--) ;
	printf("last ship slot is %d\n",ch);
	for (i=0; i<=ch && i<MAXUSHIPS; i++) {
		   printf("Ship slot #%d is ",i);
		   query(SHORT, "ship number",0,0,0,&Sdata.shipnums[i],0);
	}*/
	if (fix_mod) {
		printf("Saving...\n");
		putsdata(fix_stardata, &Sdata);
	}
	close_file(fix_stardata);
	break;

  case LEVEL_STAR:
	openstardata(&fix_stardata);
	getstar(fix_stardata, &Stars[where.snum], where.snum);

	printf("Star #%d : %s\n\n", where.snum, Stars[where.snum]->name );

	query(SHORT, "shiplist start",0,0,0,&Stars[where.snum]->ships,0);
	query(CHAR, "ActionPoints",0,0,&Stars[where.snum]->AP[Playernum-1],0,0);

	query(FLOAT,"x position",&Stars[where.snum]->xpos,0,0,0,0);
	query(FLOAT,"y position",&Stars[where.snum]->ypos,0,0,0,0);
	query(CHAR, "stability",0,0,&Stars[where.snum]->stability,0,0);
	ch = !!isset(Stars[where.snum]->explored, Playernum);
	  query(CHAR, "explored",0,0,&ch,0,0);
	if (ch)
		setbit(Stars[where.snum]->explored, Playernum);
	ch = !!isset(Stars[where.snum]->inhabited, Playernum);
	  query(CHAR, "inhabited",0,0,&ch,0,0);
		
	if (ch)
		setbit(Stars[where.snum]->inhabited, Playernum);
	ch = Stars[where.snum]->nova_stage;
	query(CHAR, "nova stage",0,0,&ch,0,0);
		Stars[where.snum]->nova_stage = ch;
	 printf("(limit %d) ",MAXPLANETS);
	query(CHAR, "# planets",0,0,&Stars[where.snum]->numplanets,0,0);
	for (i=0; i<Stars[where.snum]->numplanets; i++) {
		printf("Planet #%d (%s) ", i, Stars[where.snum]->pnames[i]);
		query(INT, "file position",0,&Stars[where.snum]->planetpos[i],0,0,0);
	}

	if (fix_mod) {
		putstar(fix_stardata, Stars[where.snum], where.snum);
		printf("Saving...\n");
	}
	close_file(fix_stardata);
	break;

  case LEVEL_PLAN:

	openpdata(&fix_pdata);
	getplanet(fix_pdata, &p, Stars[where.snum]->planetpos[where.pnum]);


	if (argc==2) {
		printf("\nPlanet / %s / %s\n", Stars[where.snum]->name, 
				Stars[where.snum]->pnames[where.pnum]);
		unl = p->info[Playernum-1].resource;
		query(LONG, "\nstockpile resources",0,0,0,0,&unl);
			p->info[Playernum-1].resource = unl;
		unl = p->info[Playernum-1].destruct;
		query(LONG, "stockpile destruct",0,0,0,0,&unl);
			p->info[Playernum-1].destruct = unl;
		unl = p->info[Playernum-1].fuel;
		query(LONG, "stockpile fuel",0,0,0,0,&unl);
			p->info[Playernum-1].fuel = unl;
		unl = p->popn;
		query(LONG, "total population(altered after turn)",0,0,0,0,&unl);
			p->popn = unl;

	i=p->info[Playernum-1].numsectsowned;
	query(INT, "numsectsowned",0,&i,0,0,0);
		p->info[Playernum-1].numsectsowned = i; 

		ch = p->info[Playernum-1].explored;
		query(CHAR, "explored",0,0,&ch,0,0);
		  p->info[Playernum-1].explored = ch;
		 printf("atmospheric cond\n");
		query(CHAR, "Temp",0,0,&p->conditions[TEMP],0,0);
		query(CHAR, "Rtemp",0,0,&p->conditions[RTEMP],0,0);
		query(CHAR, "Methane",0,0,&p->conditions[METHANE],0,0);
		query(CHAR, "Oxygen",0,0,&p->conditions[OXYGEN],0,0);
		query(CHAR, "CO2",0,0,&p->conditions[CO2],0,0);
		query(CHAR, "Hydrogen",0,0,&p->conditions[HYDROGEN],0,0);
		query(CHAR, "Nitrogen",0,0,&p->conditions[NITROGEN],0,0);
		query(CHAR, "Sulfur",0,0,&p->conditions[SULFUR],0,0);
		query(CHAR, "Helium",0,0,&p->conditions[HELIUM],0,0);
		query(CHAR, "Other",0,0,&p->conditions[OTHER],0,0);
		query(CHAR, "Toxicity",0,0,&p->conditions[TOXIC],0,0);

		query(SHORT, "shiplist start",0,0,0,&p->ships,0);
		 /*printf("(limit %d) ", MAX_X);
		query(CHAR, "sectormap size x",0,0,&p->Maxx,0,0);*/
		 /*printf("(limit %d) ", MAX_Y,0);
		query(CHAR, "sectormap size y",0,0,&p->Maxy,0,0);*/
		query(INT, "sect map file position",0,&p->sectormappos,0,0,0);
		query(FLOAT,"x position",&p->xpos,0,0,0,0);
		query(FLOAT,"y position",&p->ypos,0,0,0,0);
		ch = p->slaved_to;
		query(CHAR, "enslaved to player #",0,0,&ch,0,0);
			p->slaved_to = ch;
		/*ch = p->is_cloaked;
		query(CHAR, "cloaked",0,0,&ch,0,0);
		  p->is_cloaked = !!ch;*/

		ch = p->type;
		query(CHAR, "planet type",0,0,&ch,0,0);
		  p->type = ch;
		ch = p->info[Playernum-1].comread;
		query(CHAR, "combat readiness",0,0,&ch,0,0);
		  p->info[Playernum-1].comread = ch;
		ch = p->is_explored;
		query(CHAR, "is_explored by owner",0,0,&ch,0,0);
		  p->is_explored = !!ch;

		if (fix_mod) {
			putplanet(fix_pdata, p, Stars[where.snum]->planetpos[where.pnum]);
			printf("Saving...\n");
		}
		close_file(fix_pdata);

	} else {
			/* fix sector */
		int x,y;
		close_file(fix_pdata);
		sscanf(argv[2],"%d,%d", &x, &y);
		printf(" sector %d,%d\n",x,y);
		opensectdata(&fix_sectdata);
		getsector(fix_sectdata,&sect,p->sectormappos+(y*p->Maxx+x)*sizeof(sectortype));

		ch = sect->eff;
		query(CHAR, "efficiency",0,0,&ch,0,0);
		  sect->eff = ch;
		ch = sect->resource;
		query(CHAR, "resource deposits",0,0,&ch,0,0);
		  sect->resource = ch;
		ch = sect->fert;
		query(CHAR, "fertility",0,0,&ch,0,0);
		  sect->fert = ch;
		ch = sect->mobilization;
		query(CHAR, "mobilization",0,0,&ch,0,0);
		  sect->mobilization = ch;
		printf("(limit %d)",MAX_SECT_POPN);
		i = sect->popn;
		query(INT, "population",0,&i,0,0,0);
		  sect->popn = i;
		i = sect->owner;
		query(INT, "owner",0,&i,0,0,0);
		  sect->owner = i;
		ch = sect->is_wasted;
		query(CHAR, "is_wasted",0,0,&ch,0,0);
		  sect->is_wasted = !!ch;
		ch = sect->des;
		query(CHAR, "designation",0,0,&ch,0,0);
		  sect->des = ch;
	    /*unsigned is_cloaked : 1;	/* 1 bit: is cloaked sector */
		if (fix_mod) {
			putsector(fix_sectdata,sect,p->sectormappos+(y*p->Maxx+x)*sizeof(sectortype));
			printf("Saving...\n");
		}
		close_file(fix_sectdata);
	}
	free(p);
	break;

  case LEVEL_SHIP:
	openshdata(&fix_shdata);
	getship(fix_shdata, &sh, where.shipno);

	printf("\n%s #%d.\n", Shipnames[sh->type], where.shipno);

	ch = sh->owner;
	query(CHAR, "owner",0,0,&ch,0,0);
		sh->owner = ch;

	 unl = sh->type;
	query(LONG, "type",0,0,0,0,&unl);
	 sh->type = unl;
	query(FLOAT,"technology",&sh->tech,0,0,0,0);
	query(FLOAT,"x position",&sh->xpos,0,0,0,0);
	query(FLOAT,"y position",&sh->ypos,0,0,0,0);
	query(FLOAT,"mass",&sh->mass,0,0,0,0);

	query(FLOAT,"fuel",&sh->fuel,0,0,0,0);
	 unl = sh->destruct;
	query(LONG, "destruct cap",0,0,0,0,&unl);
	 sh->destruct = unl;
	 unl = sh->resource;
	query(LONG, "resource",0,0,0,0,&unl);
	 sh->resource = unl;
	 unl = sh->popn;
	query(LONG, "crew",0,0,0,0,&unl);
	 sh->popn = unl;

	 unl = sh->rad;
	query(LONG, "irradiated",0,0,0,0,&unl);
	 sh->rad = unl;

	 unl = sh->damage;
	query(LONG, "damage",0,0,0,0,&unl);
	 sh->damage = unl;

	ch = sh->whatorbits;
	query(CHAR, "what orbits level",0,0,&ch,0,0);
	  sh->whatorbits = ch;
	query(CHAR, "orbits what star ",0,0,&sh->storbits,0,0);
	ch = sh->pnumorbits;
	query(CHAR, "orbits what planet",0,0,&ch,0,0);
	  sh->pnumorbits = ch;
	ch = sh->whatdest;
	query(CHAR, "what destination level",0,0,&ch,0,0);
	  sh->whatdest = ch;
	query(CHAR, "what star dest",0,0,&sh->deststar,0,0);
	ch = sh->destpnum;
	query(CHAR, "what planet dest",0,0,&ch,0,0);
	  sh->destpnum = ch;
	query(SHORT, "what ship dest",0,0,0,&sh->destshipno,0);
	ch = sh->is_alive;
	 unl = sh->bombard;
	query(LONG, "bombard",0,0,0,0,&unl);
	 sh->bombard = unl;
	query(CHAR, "is alive",0,0,&ch,0,0);
	  sh->is_alive = !!ch;
	ch = sh->notified;
	query(CHAR, "notified",0,0,&ch,0,0);
	  sh->notified = !!ch;
	ch = sh->is_docked;
	query(CHAR, "is docked",0,0,&ch,0,0);
	  sh->is_docked = !!ch;
	query(SHORT, "nextship",0,0,0,&sh->nextship,0);
	/*query(SHORT, "abil_cargo",0,0,0,&sh->abils[ABIL_CARGO],0);
	query(SHORT, "abil_stealth",0,0,0,&sh->abils[ABIL_STEALTH],0);
	query(SHORT, "abil_destruct cap",0,0,0,&sh->abils[ABIL_DESTCAP],0);
	query(SHORT, "abil_num guns",0,0,0,&sh->abils[ABIL_GUNS],0);
	query(SHORT, "abil_fuel cap",0,0,0,&sh->abils[ABIL_FUELCAP],0);
	query(SHORT, "abil_tech level",0,0,0,&sh->abils[ABIL_MINTECH],0);
	query(SHORT, "abil_max crew",0,0,0,&sh->abils[ABIL_MAXCREW],0);
	query(SHORT, "abil_armor",0,0,0,&sh->abils[ABIL_ARMOR],0);*/

	  query(SHORT, "object:number",0,0,0,&sh->object.number,0);
	  query(SHORT, "object:number2",0,0,0,&sh->object.number2,0);
	  query(SHORT, "object:number3",0,0,0,&sh->object.number3,0);
	  query(SHORT, "object:number4",0,0,0,&sh->object.number4,0);


	if (fix_mod) {
		printf("Saving...\n");
		putship(fix_shdata, sh, where.shipno);
	}
	close_file(fix_shdata);
	break;


 }
}


}


query( kind, quest, fprev, iprev, cprev, sprev, lprev)
int kind;
char *quest;
float *fprev;
int *iprev;
char *cprev;
short *sprev;
long *lprev;
{
 float f;
 int i;
 char c,ch;
 short s;
 long l;

 printf("%s (", quest);
 switch (kind) {
  case FLOAT:
	printf("%f", *fprev);
	break;
  case INT:
	printf("%d", *iprev);
	break;
  case CHAR:
	printf("%d", *cprev);
	break;
  case SHORT:
	printf("%d", *sprev);
	break;
  case LONG:
	printf("%ld", *lprev);
	break;
 }
 printf(") : ");

 if ( isdigit(ch=getchr()) || ch=='-' || ch=='.') {
	ungetc(ch, stdin);
	fix_mod = 1;	/* set mod so fix knows to save data */
	switch (kind) {
	 case FLOAT:
		scanf("%f",fprev);
		break;
	 case INT:
		scanf("%d",iprev);
		break;
	 case CHAR:
		scanf("%d",&i);
		*cprev = i;  /* don't want to copy a whole int's worth */
		break;
	 case SHORT:
		scanf("%hd",sprev);
		break;
	 case LONG:
		scanf("%ld",lprev);
		break;
	}
	getchr();
  }
}


notify(Playernum, temp)
int Playernum;
char *temp;
{
/* dummy routine */
printf("%s\n", temp);
}

fix_handler()
{
 close_file(fix_stardata);
 close_file(fix_shdata);
 close_file(fix_pdata);
 close_file(fix_sectdata);
}




