/*
** Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
** smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
** Restrictions in GB_copyright.h.
**
**  land.c -- land a ship
**  also.... dock -- dock a ship w/ another ship 
**  and..... assault -- a very un-PC version of land/dock
*/

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "ships.h"
#include "races.h"
#include "buffers.h"
#include <signal.h>
#include <math.h>

int land_sectdata,land_shdata,land_pdata, land_racedata;
int land_stdata;

land(Playernum,APcount, argn,args, Assault)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
int Assault;	/* unfriendly land */
{
char c;
shiptype *s,*s2,*s3;
planettype *p;
sectortype *sect;
placetype where;
racetype *alien;
boolean Land=0,Dock=0,cont,planetmod=0,sectmod=0;
int boarders,oldspopn,olds2popn,dam,dam2,booby,
	numdest=0,ship2no,shipno,x= -1,y= -1,i,mask;
int old2owner,sh, sh3;
int sowner, s2owner, casualties, casualties2;
float fuel,bstrength,b2strength,pris;
double Dist;

land_sectdata = land_shdata = land_pdata = NEUTRAL_FD;


	sscanf(args[1]+(args[1][0]=='#'),"%d",&shipno);


free(Race);
openracedata(&land_racedata);
getrace(land_racedata, &Race, Playernum); 
close_file(land_racedata);

 openshdata(&land_shdata);
  if (!getship(land_shdata, &s, shipno)) {
      notify(Playernum, "The ship wasn't found.\n");
close_file(land_shdata);
	return;
  }
close_file(land_shdata);
  if (testship(Playernum,s, shipno)) {
      notify(Playernum, "Illegal format.\n");
	return;
	}

  if (s->is_docked) {
	sprintf(buf,"Ship #%d is already docked.\n",shipno);
		notify(Playernum, buf);
	return;
  }


  if (s->whatorbits==LEVEL_UNIV) {
     if (!enufAP(Playernum,Sdata.AP[Playernum-1], APcount)) {
	return;
	} 
 } else
     if (!enufAP(Playernum,Stars[s->storbits]->AP[Playernum-1], APcount)) { 
	return;
	}

        if(args[0][0]=='l')
		sscanf(args[2],"%d,%d",&x,&y); /* landing on a sector */
	else
		sscanf(args[2]+(args[2][0]=='#'),"%d",&ship2no);

  if (args[0][0]=='l') {
	/* the command was 'land', don't need to get stuff */
    where.level = LEVEL_PLAN;
    where.snum = s->storbits;
    where.pnum = s->pnumorbits;
    where.err = 0;
  } else {	

    where = Getplace(Playernum,args[2], 1);
    if (where.err) {
	return;
	}
  }

  if (where.level==LEVEL_PLAN)
	Land = 1;
  else if (where.level==LEVEL_SHIP)
	Dock = 1;
  else {
	sprintf(buf,"Your ship is not equipped to do that!\n");
	notify(Playernum, buf);
	return;
  }


  if (Dock) {

	ship2no = where.shipno;
	s2 = where.shipptr;
	free(where.shipptr);	/* re-get ship cuz it wasn't locked */
openshdata(&land_shdata);
     	if (!getship(land_shdata, &s2, ship2no)) {
	    close_file(land_shdata);
	    return;
		}
	close_file(land_shdata);
	
	if ( !(s->type == STYPE_FIGHTER && s2->type == STYPE_CARRIER) ) {
	   if (s2->is_docked && !Assault) {
		sprintf(buf,"ship #%d is already docked.\n",ship2no);
			notify(Playernum, buf);
		return;
	   }
	sprintf(buf,"Distance to %s #%d: %.2f.\n", s2->name, ship2no,
  		Dist = sqrt((double)Distsq(s2->xpos, s2->ypos, 
			s->xpos, s->ypos ) ) );
		notify(Playernum, buf);
	if (Dist > DIST_TO_LAND) {
	     sprintf(buf,"Ship #%d must be %.2f or closer to ship #%d.\n",
			shipno, DIST_TO_LAND, ship2no);
		notify(Playernum, buf);
		return;
	}

	fuel = 0.05 + Dist * 0.25 * (Assault ? 2.0 : 1.0);
	sprintf(buf,"This maneuver will take %.2f fuel (of %.2f.)\n\n",fuel,s->fuel);
		notify(Playernum, buf);
	if (fuel > s->fuel) {
		sprintf(buf,"Not enough fuel.\n");
			notify(Playernum, buf);
		return;
	}

	if (Assault) {
	openracedata(&land_racedata);
		getrace(land_racedata, &alien, s2->owner);
	close_file(land_racedata);

	sscanf(args[3],"%d",&boarders);
		if (boarders > MIN(s->popn, Max_crew(s2))
		    || boarders <= 0) {
			sprintf(buf,"Illegal number of boarders (max can be %d).\n",
				MIN(s->popn, Max_crew(s2)));
			notify(Playernum, buf);
			return;
		}
		old2owner = s2->owner;
		s->popn -= boarders;
		s->mass -= boarders * Race->mass;
		sprintf(buf,"Boarding strength :%.2f       Defense strength: %.2f.\n", 
		   bstrength = 0.1 * boarders * log10(Race->fighters
			* (Race->tech+1.0)
	 	        * Size(s) * 1 + 10)
			* .01 * (100 - s->damage),
		/* 1 is dummy armor */

		   b2strength = 0.1* s2->popn * log10(alien->fighters
			* (alien->tech+1.0)
	 		* Size(s2) * (Armor(s2)+1) + 10)
			* .01 * (100 - s2->damage)
				);
	notify(Playernum, buf);

	}


	 /* the ship moves into position, regardless of success of attack */
	s->fuel -= fuel;
	s->mass -= fuel * MASS_FUEL;

	s->xpos = s2->xpos + rposneg();		/* either -1 or 1 */
	s->ypos = s2->ypos + int_rand(-1,1);

	if (Assault) {
/* if the assaulted ship is docked, undock it first */
	if(s2->is_docked && s2->whatdest==LEVEL_SHIP) {
	    openshdata(&land_shdata);
	    getship(land_shdata, &s3, s2->destshipno);
	    s3->is_docked = 0;
	    s3->whatdest = LEVEL_UNIV;
	    s3->destshipno = 0;
	    putship(land_shdata, s3, s2->destshipno);
	    close_file(land_shdata);
	    free(s3);
	    s2->is_docked = 0;
	    s2->whatdest = LEVEL_UNIV;
	    s2->destshipno = 0;
	}
		 /* nuke both populations, ships */
if(b2strength) {	/* otherwise the ship surrenders */
		casualties = MIN(boarders, int_rand(0,
		       round_rand((float)boarders * b2strength / bstrength)));
		boarders -= casualties;

	        dam = MIN(100, int_rand(0, round_rand(25. * b2strength/bstrength)));
		s->damage = MIN(100, s->damage+dam);
		if (s->damage >= 100) {
			s->popn = 0;
			kill_ship(s);
			}			

		   casualties2 = MIN(s2->popn, int_rand(0,
	       		 round_rand((float)s2->popn * bstrength / b2strength)));
		   s2->popn -= casualties2;
		   s2->mass -= casualties2 * alien->mass;
			/* (their mass) */
		   dam2 = MIN(100, int_rand(0,round_rand(25. * bstrength/b2strength)));
		   s2->damage = MIN(100, s2->damage+dam2);
		   if ( s2->damage >= 100) {
			s2->popn = 0;
			kill_ship(s2);
			}
} else {
	s2->popn = 0;
/* do booby traps */
		 /* check for boobytrapping */
		if (!Max_crew(s2) && s2->destruct > 0)
			booby = MIN(100, int_rand(0,round_rand(
				     log1p((double)s2->destruct)*50)));

	}

		   if ((s2->popn == 0) &&  s->is_alive && s2->is_alive) {
				/* we got 'em */
			s->is_docked = 1;
			s->whatdest = LEVEL_SHIP;
			s->destshipno = ship2no;

			s2->is_docked = 1;
			s2->whatdest = LEVEL_SHIP;
			s2->destshipno = shipno;
			old2owner = s2->owner;
			s2->owner = Playernum;
			s2->popn = boarders;
			s2->mass += boarders * Race->mass;	/* our mass */
		   } else {		/* retreat */
			s->popn += boarders;
			s->mass += boarders * Race->mass;
		   }

	} else {
		s->is_docked = 1;
		s->whatdest = LEVEL_SHIP;
		s->destshipno = ship2no;

		s2->is_docked = 1;
		s2->whatdest = LEVEL_SHIP;
		s2->destshipno = shipno;
	}

	s->notified = s2->notified = 0;
	   openshdata(&land_shdata);
	putship(land_shdata, s, shipno);
	putship(land_shdata, s2, ship2no);
	   free(s2);
	   close_file(land_shdata);
	if (Assault) {
/* races find out about each other */
	alien->translate[Playernum-1] = MIN(alien->translate[Playernum-1]+5, 100);
	Race->translate[s2->owner-1] = MIN(Race->translate[s2->owner-1]+5, 100);
sowner = s->owner;
s2owner = s2->owner;
		sprintf(telegram_buf,"%s #%d ASSAULTED by ",
			Shipnames[s2->type], ship2no);
	         sprintf(buf,"%s #%d [%d] at %s\n", 
			Shipnames[s->type], shipno, s->owner, prin_ship_orbits(s2));
			str_cat(telegram_buf, buf);
		sprintf(buf,"Your damage: %d%%, theirs: %d%%.\n", dam2, dam);
			str_cat(telegram_buf, buf);
		if (!Max_crew(s2) && s2->destruct) {
		       sprintf(buf,"(Your boobytrap gave them %.0f%% damage.)\n",
				booby);
			str_cat(telegram_buf, buf);
			sprintf(buf,"Their boobytrap gave you %.0f%% damage!)\n",
				booby);
			notify(Playernum, buf);
		}
		sprintf(buf,"Damage taken:  You: %d%% (now %d%%)\n", dam, s->damage);
			notify(Playernum, buf);
if(!s->is_alive) {
  sprintf(buf,"              YOUR SHIP WAS DESTROYED!!!\n");
			notify(Playernum, buf);
  sprintf(buf,"              Their ship DESTROYED!!!\n");
		str_cat(telegram_buf, buf);
}
		sprintf(buf,"              Them: %d%% (now %d%%)\n",dam2,s2->damage);
			notify(Playernum, buf);
if(!s2->is_alive) {
  sprintf(buf,"              Their ship DESTROYED!!!  Boarders are dead.\n");
			notify(Playernum, buf);
  sprintf(buf,"              YOUR SHIP WAS DESTROYED!!!\n");
		str_cat(telegram_buf, buf);
}
		if (s->is_alive) {
			if (s2->owner==Playernum) {
				sprintf(buf,"CAPTURED!\n");
					str_cat(telegram_buf, buf);
				sprintf(buf,"VICTORY! the ship is yours!\n");
					notify(Playernum, buf);
				if (boarders) {
				  sprintf(buf,"%d boarders move in.\n", boarders);
					notify(Playernum, buf);
					}

	Race->translate[s2owner-1] = MIN(Race->translate[s2owner-1]+25, 100);

			} else if(s2->popn) {
				sprintf(buf,"The boarding was repulsed; try again.\n");
					notify(Playernum, buf);
				sprintf(buf,"You fought them off!\n");
					str_cat(telegram_buf, buf);
			}
		} else {
			sprintf(buf,"The assault was too much for your bucket of bolts.\n");
					notify(Playernum, buf);
			sprintf(buf,"The assault was too much for their ship..\n");
				str_cat(telegram_buf, buf);
		}
		if (s2->is_alive) {
			if (!boarders) {
				sprintf(buf,"Oh no! They killed your boarding party to the last man!\n");
					notify(Playernum, buf);
	alien->translate[sowner-1] = MIN(alien->translate[sowner-1]+25, 100);
			}

			if (!s->popn) {
				sprintf(buf,"You killed all their crew!\n");
				str_cat(telegram_buf, buf);
			} 
		} else {
			sprintf(buf,"The assault weakened their ship too much!\n");
				notify(Playernum, buf);				
			sprintf(buf,"Your ship was weakened too much!\n");
				str_cat(telegram_buf, buf);
		}
		sprintf(buf,"Casualties: Yours: %d     Theirs: %d\n", casualties2, casualties);
			str_cat(telegram_buf, buf);
		sprintf(buf,"Crew casualties: Yours: %d     Theirs: %d\n", casualties, casualties2);
			notify(Playernum, buf);
			if(!notify(old2owner, telegram_buf))
			    push_message(TELEG_PLAYER_AUTO, old2owner, telegram_buf);
openracedata(&land_racedata);
putrace(land_racedata, Race);
putrace(land_racedata, alien);
close_file(land_racedata);

	} else {
		sprintf(buf,"ship #%d docked with ship #%d.\n",shipno, ship2no);
			notify(Playernum, buf);
		}

	} else {
		/* docking fighters with a carrier */

	if(s->whatorbits==LEVEL_PLAN)
		{
     openpdata(&land_pdata);
     getplanet(land_pdata, &p, Stars[s->storbits]->planetpos[s->pnumorbits]);

	sh = p->ships;
	if(sh == shipno){
		p->ships = s->nextship;
		putplanet(land_pdata, p, Stars[s->storbits]->planetpos[s->pnumorbits]);
	    } else {
openshdata(&land_shdata);
	    while(sh != shipno){
		getship(land_shdata, &s3, sh);
		sh3 = sh;
		sh = s3->nextship;
	  }
	  s3->nextship = s->nextship;
	  if(sh3 == ship2no)s2->nextship = s3->nextship;
	  putship(land_shdata, s3, sh3);
	  close_file(land_shdata);
free(s3);
}
      close_file(land_pdata);
		}


	if(s->whatorbits==LEVEL_STAR)
		{
     openstardata(&land_stdata);
     getstar(land_stdata, &Stars[s->storbits], s->storbits);

	sh = Stars[s->storbits]->ships;
	if(sh == shipno){
		Stars[s->storbits]->ships = s->nextship;
	putstar(land_stdata, Stars[s->storbits], s->storbits);
			} else {
	openshdata(&land_shdata);
	while(sh != shipno){
     	getship(land_shdata, &s3, sh);
	sh3 = sh;
	sh = s3->nextship;
    }
	s3->nextship = s->nextship;
	if(sh3 == ship2no)s2->nextship = s3->nextship;

	putship(land_shdata, s3, sh3);
	close(land_shdata);
	free(s3);
    }

     close_file(land_stdata);
		}


		s->fuel -= fuel;
		s->mass -= fuel * MASS_FUEL;
		s->is_docked = 1;
		s->whatdest = LEVEL_SHIP;
		s->whatorbits = LEVEL_UNIV;
		s->destshipno = ship2no;
		s->nextship = 0;

		s->xpos = s2->xpos;
		s->ypos = s2->ypos;

		s->object.number = s2->object.number;
		s->object.number4 = 1; /* docked with carrier */

		 /* remove fighter from upper level linked list */
		s2->object.number = shipno;
		s2->object.number4 += 1; /* number of fighters docked */
		s2->mass += s->mass;

		s->notified = s2->notified = 0;
	openshdata(&land_shdata);
	putship(land_shdata, s, shipno);
		putship(land_shdata, s2, ship2no);
	free(s2);
	close(land_shdata);
    }

  } else {	/* docking with a planet */

     if (s->whatorbits!=LEVEL_PLAN) {
	sprintf(buf,"%s #%d doesn't orbit a planet.\n", Shipnames[s->type],
		shipno);
		notify(Playernum, buf);
	return;
     }
     if (Assault && s->popn < 1) {
	sprintf(buf,"The assaulting ship must have >= 1 crew.\n");
		notify(Playernum, buf);
	return;
     }

    if(s->storbits != Dir[Playernum-1].snum || s->pnumorbits != Dir[Playernum-1].pnum)
    	{
	sprintf(buf,"Wrong scope!\n");
		notify(Playernum, buf);
	return;
	}


     openpdata(&land_pdata);
     getplanet(land_pdata, &p, Stars[s->storbits]->planetpos[s->pnumorbits]);
     close_file(land_pdata);
     
     sprintf(buf,"Planet /%s/%s has gravity field of %.2f.\n", Stars[s->storbits]->name,
	Stars[s->storbits]->pnames[s->pnumorbits], gravity(p));
		notify(Playernum, buf);

     sprintf(buf,"Distance to planet: %.2f.\n",
  	Dist = sqrt((double)Distsq(Stars[s->storbits]->xpos + p->xpos, 
  		      Stars[s->storbits]->ypos + p->ypos, 
  		      s->xpos, s->ypos ) )
  	);
		notify(Playernum, buf);

     if (Dist > DIST_TO_LAND) {
        sprintf(buf,"Ship #%d must be %.3g or closer to the planet (%.2f).\n",shipno, DIST_TO_LAND, Dist);
		notify(Playernum, buf);
	return;
     }

     fuel = 0.05 + logscale((int)s->mass)*gravity(p) * LAND_GRAV_MASS_FACTOR + Assault;

     if (fuel < s->fuel) {
  	if (!Shipdata[s->type][ABIL_CANLAND] && !Dock) {
		sprintf(buf,"This ship is not equipped to land.\n");
		notify(Playernum, buf);
		return;
  	}
  	if (!speed_rating(s)) {
		sprintf(buf,"This ship is not rated for maneuvering.\n");
		notify(Playernum, buf);
		return;
  	}
  	if (!Dock && (s->resource > Max_resource(s)
	    || s->fuel > Max_fuel(s)
	    || s->popn > Max_crew(s)
	    || s->destruct > Max_destruct(s))) {
		sprintf(buf,"Ship is too overloaded to land.\n");
		notify(Playernum, buf);
		return;
  	}
     }

     sprintf(buf,"That maneuver costs %.2f fuel (of %.2f).\n",fuel, s->fuel);
		notify(Playernum, buf);

     if (s->fuel < fuel) {
	  sprintf(buf,"NOT ENOUGH FUEL ");
		notify(Playernum, buf);
		return;
     }

     cont = 1;
     do {

	if(x < 0 || y < 0 || x > p->Maxx || y > p->Maxy) {
		sprintf(buf,"Illegal coordinates.\n");
			notify(Playernum, buf);
			return;
			}
	opensectdata(&land_sectdata);
	getsector(land_sectdata,&sect,p->sectormappos+(y*p->Maxx+x)*sizeof(sectortype));
	close_file(land_sectdata);
       if(s->type != OTYPE_TERRA) {
       if (Race->likes[sect->des] == 0.0 && !sect->is_wasted) {
	sprintf(buf,"The ship is not built to land on that sector.\n");
		notify(Playernum, buf);
	return;
       }
       if (sect->is_wasted) {
	sprintf(buf,"Warning: That sector is a wasteland!\n");
		notify(Playernum, buf);
       }
     }
       if (Assault) {
	    if (sect->owner==Playernum) {
		sprintf(buf,"You cannot assault your own sector.\n");
		notify(Playernum, buf);
		return;
	    } else if (sect->popn > 0) {
		sprintf(buf,"The assaulted sector must have no population.\n");
		notify(Playernum, buf);
		return;
	    }
       } else if (sect->owner && sect->owner!=Playernum) {
	openracedata(&land_racedata);
	 getrace(land_racedata, &alien, sect->owner);
	close_file(land_racedata);

       if(!(isset(Race->allied, sect->owner) && 
	    isset(alien->allied, Playernum))) {
	sprintf(buf,"You are not mutually allied with %s.\n", alien->name);
		notify(Playernum, buf);
	return;
      } else {
	sprintf(buf,"You have landed on allied sector (%s).\n",alien->name);
		notify(Playernum, buf);
      }
       }
       if (!cont)
	free(sect);


     } while (!cont);

     if (s->fuel < fuel) {


	kill_ship(s);
openshdata(&land_shdata);
	putship(land_shdata, s, shipno);
	close(land_shdata);
	free(s);

	if (!fork()) {
		/* fork off a child process to do damage */
	  where.level = LEVEL_PLAN;
	  where.snum = s->storbits;
	  where.pnum = s->pnumorbits;

	  /* first "where" is dummy-- just checks to see if it's a GR
	     laser; we don't need it */
	  numdest = blast(Playernum,&where, &where, 0, p, x, y, Dist, 100.,
			round_rand(log1p((double)s->mass)*2+(float)s->destruct/3.), 1);
	  sprintf(buf,"BOOM!! Ship #%d crashes on sector %d,%d with blast radius of %d.\n",
		shipno, x, y, numdest);
		notify(Playernum, buf);

	  exit(0);
	}

     } else {
  
   
     	s->xpos = (float)x;
     	s->ypos = (float)y;

     	s->fuel -= fuel;
     	s->mass -= fuel * MASS_FUEL;
     	s->is_docked = 1;
     	s->whatdest = LEVEL_PLAN;	/* no destination */
     	s->deststar = s->storbits;
     	s->destpnum = s->pnumorbits;

     	if (Assault) {
		/* assault on planet increases combat readiness, */
		/* but only if we aren't already well-established there */
	  if (p->info[Playernum-1].numsectsowned==0 && p->info[Playernum-1].comread < 50) {
		p->info[Playernum-1].comread = 100;
		p->info[Playernum-1].mob_set = 100;
		sect->mobilization = 100;
		sect->is_wasted = 0;
	  }
	  sectmod = planetmod = 1;
	   /* unload some people onto the sector */
	  sect->popn = s->popn-1;
	  s->mass -= (s->popn-1) * Race->mass;
	  s->popn = 1;
	  sect->owner = Playernum;
	  p->info[Playernum-1].numsectsowned++;
       }
     }
     s->notified = 0;	/* reset notification */
openshdata(&land_shdata);
     putship(land_shdata, s, shipno);
  close_file(land_shdata);

  }



  if (s->whatorbits==LEVEL_UNIV)
	  deductAPs(Playernum,APcount, 0, 1);
  else
	  deductAPs(Playernum,APcount, s->storbits, 0);


  if (!Dock) {
      if (planetmod) {
	  openpdata(&land_pdata);
	  putplanet(land_pdata,p,Stars[s->storbits]->planetpos[s->pnumorbits]);
      close_file(land_pdata);
      }
   /* */
opensectdata(&land_sectdata);
      if (sectmod && !numdest)
	  putsector(land_sectdata,sect,p->sectormappos+(y*p->Maxx+x)*sizeof(sectortype));
      close_file(land_sectdata);
      free(sect);

	/* send telegs to anyone there */
	  if (Assault) {
		  sprintf(telegram_buf,"Planet /%s/%s ",
			Stars[s->storbits]->name,
			Stars[s->storbits]->pnames[s->pnumorbits]);
		  sprintf(buf,"ASSAULTED by %s #%d on sector %.0f,%.0f!!\n", 
			Shipnames[s->type], shipno, s->xpos, s->ypos);
			str_cat(telegram_buf, buf);
	  } else {
		  sprintf(telegram_buf,"%s #%d observed landing on sector %.0f,%.0f, planet /%s/%s.\n",
			Shipnames[s->type], shipno, s->xpos,s->ypos,Stars[s->storbits]->name,
			Stars[s->storbits]->pnames[s->pnumorbits]);
			str_cat(telegram_buf, buf);
	  }
	  for (i=1; i<=Numraces(); i++)
		if (p->info[i-1].numsectsowned && i!=Playernum) {
			notify(i, telegram_buf);
			}
   free(p);

  	  sprintf(buf,"%s #%d %s landed on planet.\n",Shipnames[s->type],
		 shipno,s->name);
		notify(Playernum, buf);
  }

openracedata(&land_racedata);
putrace(land_racedata, Race);
close(land_racedata);

  free(s);

}


