/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 *
 * name.c -- rename something to something else
* announce.c -- make announcements in the system you currently in.
*			You must be inhabiting that system for your message to sent.
*			You must also be in that system (and inhabiting) to receive announcements.
* page.c -- send a message to a player requesting his presence in a system. 
*/

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "races.h"
#include "ships.h"
#include "buffers.h"
#include <ctype.h>
#include <signal.h>
#include <strings.h>
#include <time.h>
int name_shdata,name_stardata, name_racedata, name_pdata;

char msg[1024];
struct tm *current_tm;/* for watching for next update */
long clk;

give(Playernum, APcount, argn, args)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
int who, sh;
shiptype *ship;
planettype *planet;
racetype *alien;

free(Race);
openracedata(&name_racedata);
getrace(name_racedata, &Race, Playernum);
close_file(name_racedata);

GetPlayer(args[1], &who, &alien);
   if (who <= 0) {
	sprintf(buf,"No such player.\n");
		notify(Playernum, buf);
	return;
   }

      /* check to see if both players are mutually allied */
if(!(isset(Race->allied, who) && isset(alien->allied, Playernum))) {
      notify(Playernum, "You two are not mutually allied.\n");
      return;
}
sscanf(args[2]+(args[2][0]=='#'), "%d", &sh);

		openshdata(&name_shdata);
		if(!getship(name_shdata, &ship, sh)) {
		    notify(Playernum, "Illegal ship number.\n");
		    close_file(name_shdata);
		    return;
		}
                if(ship->owner != Playernum || !ship->is_alive) {
		    DontOwnErr(Playernum, sh);
		    free(ship);
		    close_file(name_shdata);
		    return;
		}
if(ship->type == STYPE_POD) {
    notify(Playernum, "You cannot change the ownership of spore pods.\n");
    			free(ship);
		    close_file(name_shdata);
		    return;
}

if(ship->popn && !Race->God) {
	notify(Playernum, "You can't give this ship away while it has crew on board.\n");
	free(ship);
	close_file(name_shdata);
	return;
	}

switch(ship->whatorbits) { 
	case LEVEL_UNIV:
		if(!enufAP(Playernum, Sdata.AP[Playernum-1], APcount))
			return;
		break;
	default:
		if (!enufAP(Playernum,Stars[Dir[Playernum-1].snum]->AP[Playernum-1], APcount))
			return;
		break;
	}

ship->owner = who;
putship(name_shdata, ship, sh);
close_file(name_shdata);

/* set inhabited/explored bits */
switch(ship->whatorbits) {
  case LEVEL_UNIV:
    break;
  case LEVEL_STAR:
    free(Stars[ship->storbits]);
    openstardata(&name_stardata);
    getstar(name_stardata, &(Stars[ship->storbits]), ship->storbits);
    setbit(Stars[ship->storbits]->inhabited, who);
    setbit(Stars[ship->storbits]->explored, who);
    putstar(name_stardata, Stars[ship->storbits], ship->storbits);
    close_file(name_stardata);
    break;
  case LEVEL_PLAN:
    free(Stars[ship->storbits]);
    openstardata(&name_stardata);
    getstar(name_stardata, &(Stars[ship->storbits]), ship->storbits);
    setbit(Stars[ship->storbits]->inhabited, who);
    setbit(Stars[ship->storbits]->explored, who);
    putstar(name_stardata, Stars[ship->storbits], ship->storbits);
    close_file(name_stardata);
    openpdata(&name_pdata);
    getplanet(name_pdata, &planet, Stars[ship->storbits]->planetpos[ship->pnumorbits]);
    planet->info[who-1].explored = 1;
    putplanet(name_pdata, planet, Stars[ship->storbits]->planetpos[ship->pnumorbits]);
    close_file(name_pdata);
    break;
  default:
    notify(Playernum, "Something wrong with this ship's scope.\n");
	free(ship);
    return;
    break;
}

switch(ship->whatorbits) { 
	case LEVEL_UNIV:
		deductAPs(Playernum, APcount, 0, 1);
			return;
		break;
	default:
		deductAPs(Playernum,APcount, Dir[Playernum-1].snum, 0);
		break;
	}


notify(Playernum, "Owner changed.\n");
sprintf(buf, "%s [%d] gave you %s #%d at %s.\n", Race->name, Playernum,
	Shipnames[ship->type], sh, prin_ship_orbits(ship));
notify(who, buf);
push_message(TELEG_PLAYER_AUTO, who, buf);

                    free(ship);
}


page(Playernum, APcount0, argn, args)
int Playernum;
int APcount0;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
int i, who, to_block, dummy, APcount;
racetype *alien;

APcount = APcount0;
to_block = 0;
if(!strcmp(args[1], "block", strlen(args[1]))) {
    to_block = 1;
    notify(Playernum, "Paging alliance block.\n");
} else {
   GetPlayer(args[1], &who, &alien);
   if (who <= 0) {
	sprintf(buf,"No such player.\n");
		notify(Playernum, buf);
	return;
   }
APcount *= !alien->God;
}

free(Race);
openracedata(&name_racedata);
getrace(name_racedata, &Race, Playernum); 
close_file(name_racedata);

	switch(Dir[Playernum-1].level) {
		case LEVEL_UNIV:
			sprintf(buf, "You can't make pages at universal scope.\n");
			notify(Playernum, buf);
			break;
		default:
			free(Stars[Dir[Playernum-1].snum]);
			openstardata(&name_stardata);
		getstar(name_stardata, &Stars[Dir[Playernum-1].snum], Dir[Playernum-1].snum);
			close_file(name_stardata);
			if (!enufAP(Playernum,Stars[Dir[Playernum-1].snum]->AP[Playernum-1], APcount)) {
			return;
		}

		sprintf(buf, "%s page(s) you from the %s star system.\n",
			Race->name, Stars[Dir[Playernum-1].snum]->name);
		if(to_block) {
		  dummy = (Blocks[Playernum-1].invite &
			      Blocks[Playernum-1].pledge);
		  for(i=1; i<=Numraces(); i++)
		      if(isset(dummy, i) && i!=Playernum)
			  notify(i, buf);
	      } else
			notify(who, buf);

			notify(Playernum, "Request sent.\n");
			break;
		}
	deductAPs(Playernum, APcount, Dir[Playernum-1].snum, 0);
}

send_message(Playernum, APcount0, argn, args)
int Playernum;
int APcount0;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
int who, i, j, to_block, dummy, APcount;
racetype *alien;

    APcount = APcount0;

to_block = 0;
if(!strcmp(args[1], "block", strlen(args[1]))) {
    to_block = 1;
    notify(Playernum, "Sending message to alliance block.\n");
} else {
GetPlayer(args[1], &who, &alien);
   if (who <= 0) {
	sprintf(buf,"No such player.\n");
		notify(Playernum, buf);
	return;
   }
APcount *= !alien->God;
}

free(Race);
openracedata(&name_racedata);
getrace(name_racedata, &Race, Playernum); 
close_file(name_racedata);

	switch(Dir[Playernum-1].level) {
		case LEVEL_UNIV:
			sprintf(buf, "You can't send messages from universal scope.\n");
			notify(Playernum, buf);
			break;
		default:
			free(Stars[Dir[Playernum-1].snum]);
			openstardata(&name_stardata);
		getstar(name_stardata, &Stars[Dir[Playernum-1].snum], Dir[Playernum-1].snum);
			close_file(name_stardata);
			if (!enufAP(Playernum,Stars[Dir[Playernum-1].snum]->AP[Playernum-1], APcount)) {
			return;
		}

/* send the message */
	sprintf(msg, "From %s [%d]: ", Race->name, Playernum);
	       
/* put the message together */
		for(j=2; j < argn; j++)	
			{
			sprintf(buf, "%s ", args[j]);
			strcat(msg, buf);			
			}
/* post it */
		sprintf(buf, "%s has sent you a telegram. Use `read' to read it.\n", Race->name);
		if(to_block) {
		  dummy = (Blocks[Playernum-1].invite &
			      Blocks[Playernum-1].pledge);
		  Num_races = Numraces();
		  for(i=1; i<=Num_races; i++)
		      if(isset(dummy, i) && i!=Playernum) {
		          push_message(Playernum, i, msg); 
			  notify(i, buf);
		      }
		      } else {
		  push_message(Playernum, who, msg); 
		  notify(who, buf);
	      }

			notify(Playernum, "Message sent.\n");

     if(!to_block) {
/* translation modifier increases */
	alien->translate[Playernum-1] = MIN(alien->translate[Playernum-1]+2, 100);
	openracedata(&name_racedata);
	putrace(name_racedata, alien);	
	close_file(name_racedata);
               }
			break;
		    }

deductAPs(Playernum, APcount, Dir[Playernum-1].snum, 0);
}

read_messages(Playernum, APcount, argn, args)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
int i;
teleg_read(Playernum);
}


announce(Playernum, APcount, argn, args, broadcast)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
int broadcast;
{
int i, j;

free(Race);
openracedata(&name_racedata);
getrace(name_racedata, &Race, Playernum); 
close_file(name_racedata);

switch(Dir[Playernum-1].level) {
	case LEVEL_UNIV:
		sprintf(buf, "You can't make announcements at universal scope.\n");
			notify(Playernum, buf);
		break;
	default:
		free(Stars[Dir[Playernum-1].snum]);
		openstardata(&name_stardata);
		getstar(name_stardata, &Stars[Dir[Playernum-1].snum], Dir[Playernum-1].snum);
		close_file(name_stardata);
		if (!enufAP(Playernum,Stars[Dir[Playernum-1].snum]->AP[Playernum-1], APcount)) {
			return;
		}
	if(!(!!isset(Stars[Dir[Playernum-1].snum]->inhabited, Playernum) || Race->God)) {
			sprintf(buf, "You do not inhabit this system or have diety privileges.\n");
			notify(Playernum, buf);
			return;
		}

if(!broadcast)
	sprintf(msg, "%s : ", Race->name);
else
	sprintf(msg, "Interstellar broadcast from %s :", Race->name);

	Num_races = Numraces();

		for(j=1; j < argn; j++)	
			{
			sprintf(buf, "%s ", args[j]);
			strcat(msg, buf);			
			}
			strcat(msg, "\n");

	for(i=1; i<=Num_races; i++) 
		if(i != Playernum) {
		free(Race);
	openracedata(&name_racedata);
		getrace(name_racedata, &Race, i); 
	close_file(name_racedata);

	if(broadcast || (Dir[i-1].level != LEVEL_UNIV && (Dir[i-1].snum == Dir[Playernum-1].snum) 
			&&  (!!isset(Stars[Dir[Playernum-1].snum]->inhabited, i) || Race->God)))
			notify(i, msg);
	}

		break;
	}

	deductAPs(Playernum,APcount, Dir[Playernum-1].snum, 0);
}

name(Playernum,APcount, argn,args)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
char *ch;
register int i, s, spaces;
boolean check=0;
shiptype *ship;
startype *star;
planettype *p;
char string[1024];
char temp[128];

name_stardata = NEUTRAL_FD;

free(Race);
openracedata(&name_racedata);
getrace(name_racedata, &Race, Playernum);
close_file(name_racedata);

if(!isalnum(args[2][0]) || argn < 3) {
		notify(Playernum, "Illegal name format.\n");
		return;
		}

sprintf(buf, "%s", args[2]);
		for(i=3; i < argn; i++)	
			{
			sprintf(temp, " %s", args[i]);
			strcat(buf, temp);			
			}

sprintf(string, "%s", buf);

	i=strlen(args[0]);

  	/* make sure there are no ^'s or '/' in name, 
		also make sure the name has at least 1 character in it */
  ch = string;
  spaces = 0;
  while (*ch!='\0') {
	  check |= ((!isalnum(*ch) && !(*ch==' ')) || (*ch=='/') );
	  ch++;
	  if(*ch==' ') spaces++;
	}

	if(spaces==strlen(buf)) {				/* keep a player */
		notify(Playernum, "Illegal name.\n");
		return;
		}

  if (strlen(buf) < 1 || check) {
	sprintf(buf, "Illegal name %s.\n", check ? "form" : "length" );
		notify(Playernum, buf);
	return;
  }

        if (!strncmp(args[1],"ship",i)) {
		if(Dir[Playernum-1].level == LEVEL_SHIP) {
		openshdata(&name_shdata);
		getship(name_shdata, &ship, Dir[Playernum-1].shipno);

		sprintf(ship->name, "%s", buf);
		putship(name_shdata, ship, Dir[Playernum-1].shipno);
		close_file(name_shdata);
			notify(Playernum, "Name set.\n");
			free(ship);
			return;
		} else {
			notify(Playernum, "You have to 'cs' to a ship to name it.\n");
			return;
		}
        } else if (!strncmp(args[1],"class",i)) {
		if(Dir[Playernum-1].level == LEVEL_SHIP) {
		openshdata(&name_shdata);
		getship(name_shdata, &ship, Dir[Playernum-1].shipno);
	if(ship->type != OTYPE_FACTORY) {
		notify(Playernum, "You are not at a factory!\n");
		free(ship);
		close_file(name_shdata);
		return;
		}
	if(ship->on) {
		notify(Playernum, "This factory is already on line.\n");
		free(ship);
		close_file(name_shdata);
		return;
		}

		sprintf(ship->class, "%s", buf);
		putship(name_shdata, ship, Dir[Playernum-1].shipno);
		close_file(name_shdata);
			notify(Playernum, "Class set.\n");
			free(ship);
			return;
		} else {
			notify(Playernum, "You have to 'cs' to a factory to name the ship class.\n");
			return;
		}
        } else if (!strncmp(args[1], "block", i)) {
/* name your alliance block */
	sprintf(Blocks[Playernum-1].name, "%s", args[2]);
	Putblock(Blocks);
	notify(Playernum, "Done.\n");
	}else if (!strncmp(args[1],"star",i)) {

		if(Dir[Playernum-1].level == LEVEL_STAR) {

		if (!Race->God) {
			notify(Playernum, "Only dieties may name a star.\n");
			return;
		}

/* got to get all stars, to stop cheaters */
			openstardata(&name_stardata);
			for (s=0; s<Sdata.numstars; s++) {
			    free(Stars[s]);
			    getstar(name_stardata, &Stars[s], s);
				}
			close_file(name_stardata);

			for(s=0; s<Sdata.numstars; s++) {
				if(s!=Dir[Playernum-1].snum)
					if(!strcmp(Stars[s]->name, buf, strlen(Stars[s]->name)))
						{
			notify(Playernum, 
				"Thats not fair trying to name a star that! 50 APs deducted for cheating!!!\n");
						return;
						}
				}


/* check to see if there are any other stars with this name - stops cheaters */
	

sprintf(Stars[Dir[Playernum-1].snum]->name, "%s", buf);
			openstardata(&name_stardata);
			putstar(name_stardata, Stars[Dir[Playernum-1].snum], 
			Dir[Playernum-1].snum);
		close_file(name_stardata);
		} else {
			notify(Playernum, "You have to 'cs' to a star to name it.\n");
			return;
		}
        } else if (!strncmp(args[1],"planet",i)) {
		if(Dir[Playernum-1].level == LEVEL_PLAN) {
		    free(Stars[Dir[Playernum-1].snum]);
		    openstardata(&name_stardata);
			getstar(name_stardata, &Stars[Dir[Playernum-1].snum], Dir[Playernum-1].snum);
			close_file(name_stardata);

			if (!Race->God && !MostAPs(Playernum,Stars[Dir[Playernum-1].snum])) {
	  notify(Playernum,"You don't have the most AP's in that system.\n");
		return;
			}

for(s=0; s<Stars[Dir[Playernum-1].snum]->numplanets; s++)
			if(!strcmp(Stars[Dir[Playernum-1].snum]->pnames[s], buf, 
				strlen(Stars[Dir[Playernum-1].snum]->pnames[s])))
				{
				notify(Playernum, 
					"Sorry, that name is already taken. 50 APs deducted for cheating!!!\n");
				return;
				}


sprintf(Stars[Dir[Playernum-1].snum]->pnames[Dir[Playernum-1].pnum], "%s", buf);
			openstardata(&name_stardata);
			putstar(name_stardata, Stars[Dir[Playernum-1].snum],  Dir[Playernum-1].snum);
			close_file(name_stardata);
		deductAPs(Playernum, APcount, Dir[Playernum-1].snum, 0);

		} else {
			notify(Playernum, "You have to 'cs' to a planet to name it.\n");
			return;
		}
        } else if (!strncmp(args[1],"race",i)) {
sprintf(Race->name, "%s", buf);
if(Playernum==1) Race->God = 1; /* for careless dieties*/
	openracedata(&name_racedata);
		putrace(name_racedata, Race);
	close_file(name_racedata);

	} else {
		notify(Playernum, "I don't know what you mean.\n");
		return;
	}	

}


int MostAPs(Playernum,s)
int Playernum;
startype *s;
{
 register int i,t = 0;

  for (i=0; i<MAXPLAYERS; i++)
     if (s->AP[i] >= t)
	  t = s->AP[i];

  return (s->AP[Playernum-1] == t);

}


