/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 *
 * Galactic Bloodshed (Robert Chansky, smq@ucscb.ucsc.edu)
 * power.c -- display power report
 */

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "races.h"
#include "power.h"
#include "buffers.h"
#include <errno.h>
#include <time.h>
extern int errno;
extern struct tm *update_tm;
int power_racedata;

block(Playernum,APcount, argn,args)
int Playernum;
int APcount, argn;
char args[MAXARGS][COMMANDSIZE];
{
register int i,n;
int power_fd, p;
racetype *r;
int dummy;

	  n = Numraces();

if(argn > 1) {

p = -1;
	GetPlayer(args[1], &p, &r);
if(p == -1) {
	notify(Playernum, "No such player,\n");
	return;
	}

/* list the players who are in this alliance block */
	dummy=(Blocks[p-1].invite & Blocks[p-1].pledge);

 sprintf(buf,"         ========== %s Power Report ==========\n",
			Blocks[p-1].name);
	notify(Playernum, buf);
  sprintf(buf," #  Name               sects   popn eff mob #shp #plan    res   fuel   dest\n");
	notify(Playernum, buf);

openracedata(&power_racedata);
for(i=1; i<=n; i++)
	if(isset(dummy, i)) {
		  getrace(power_racedata, &r,i);
		  sprintf(buf,"%2d %-20.20s%5u%7u%4.0f%4.0f%5u%6u%7u%7u%7u\n",
			i, r->name,
			Power[i-1].sectors_owned, Power[i-1].popn, 
			Power[i-1].sectors_owned ? 
				(float)Power[i-1].sum_eff/Power[i-1].sectors_owned : 0.0,
			Power[i-1].sectors_owned ? 
				(float)Power[i-1].sum_mob/Power[i-1].sectors_owned : 0.0,
			Power[i-1].ships_owned, Power[i-1].planets_owned,
			Power[i-1].resource, Power[i-1].fuel, Power[i-1].destruct);
		  free(r);
	notify(Playernum, buf);
		}
close_file(power_racedata);

	} else {   /* list power report for all the alliance blocks (as of the last update) */
 sprintf(buf,"         ========== Alliance Blocks as of %s ==========\n",
			Power_blocks.time);
	notify(Playernum, buf);
  sprintf(buf," #  Name                 #  sects    popn #shp #plan    res   fuel   dest   VPs\n");
	notify(Playernum, buf);
	for(i=1; i<=n; i++) 
		if(Power_blocks.members[i-1] > 1) {
		  sprintf(buf,"%2d %-19.19s%3d%7u%8u%5u%6u%7u%7u%7u%7u\n",
			i, Blocks[i-1].name, Power_blocks.members[i-1],
			Power_blocks.sectors_owned[i-1], Power_blocks.popn[i-1], 
			Power_blocks.ships_owned[i-1], Power_blocks.planets_owned[i-1],
			Power_blocks.resource[i-1], Power_blocks.fuel[i-1],
			Power_blocks.destruct[i-1], Power_blocks.VPs[i-1]);
		notify(Playernum, buf);
		}

	}

}



power(Playernum,APcount, argn,args)
int Playernum;
int APcount, argn;
char args[MAXARGS][COMMANDSIZE];
{
register int i,n;
int power_fd, p;
racetype *r;

p = -1;
if(argn>=2) {
	GetPlayer(args[1], &p, &r);
if(p == -1) {
	notify(Playernum, "No such player,\n");
	return;
	}
	}

openracedata(&power_racedata);
free(Race);
getrace(power_racedata, &Race, Playernum); 

 sprintf(buf,"         ========== Galactic Bloodshed Power Report ==========\n");
	notify(Playernum, buf);
  sprintf(buf," #  Name               sects   popn eff mob #shp #plan    res   fuel   dest\n");
	notify(Playernum, buf);

	  n = Numraces();
	  for (i=1; i<=n; i++) 
		if(argn < 2 || i==p) {
		  getrace(power_racedata, &r,i);
		  sprintf(buf,"%2d %-20.20s%5u%7u%4.0f%4.0f%5u%6u%7u%7u%7u\n",
			i, r->name,
			Power[i-1].sectors_owned, Power[i-1].popn, 
			Power[i-1].sectors_owned ? 
				(float)Power[i-1].sum_eff/Power[i-1].sectors_owned : 0.0,
			Power[i-1].sectors_owned ? 
				(float)Power[i-1].sum_mob/Power[i-1].sectors_owned : 0.0,
			Power[i-1].ships_owned, Power[i-1].planets_owned,
			Power[i-1].resource, Power[i-1].fuel, Power[i-1].destruct);
		  free(r);
	notify(Playernum, buf);
	  }
close_file(power_racedata);
}
