/*
** Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
** smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
** Restrictions in GB_copyright.h.
**
**   Random number generator
**
**	float float_rand() this returns a random number between 0 and 1
**
**	int int_rand(low,hi) -	this returns an integer random number
**				between hi and low, inclusive.
**
**	int round_rand(float) - returns float rounded to integer, with
**				proportional chance of rounding up or
**				down.
**
**	int rposneg() - either -1 or 1
*/

#include "GB_copyright.h"

long random();


float float_rand()
{
	return random()/ 2147483648.0;
}

int int_rand(low,hi)
register int low,hi;
{
    return( (hi<=low) ? low : (random() % (hi - low + 1)) + low );
}


int round_rand(x)
register float x;
{
  return ( (float_rand() > (x-(int)x)) ? (int)x : (int)(x+1) );
}

int rposneg()
{
  return( (random()&1) ? -1 : 1 );
}
