/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 *
 * survey.c -- print out survey for planets  
 */

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "ships.h"
#include "races.h"
#include "buffers.h"
#include <string.h>
#include <ctype.h>
extern float compatibility();
extern char desshow();
extern char *Desnames[];
	/* user's guide to toxicity */
char *Tox[] = {
	"Stage 0, mild",
	"Stage 1, mild",
	"Stage 2, semi-mild",
	"Stage 3, semi-semi mild",
	"Stage 4, ecologically unsound",
	"Stage 5: ecologically unsound",
	"Stage 6: below birth threshold",
	"Stage 7: ecologically unstable--below birth threshold",
	"Stage 8: ecologically poisonous --below birth threshold", 
	"Stage 9: WARNING: nearing 100% toxicity",
	"Stage 10: WARNING: COMPLETELY TOXIC!!!",
	"???"
};
int survey_racedata;


survey(Playernum,APcount, argn,args)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
int lowx,hix,lowy,hiy,x2;
char d;
sectortype *s;
planettype *p;
int tindex,survey_pdata,survey_sectdata;
placetype where;
float compat;

if (argn==1) {   /* no args */

	where.level = Dir[Playernum-1].level;
	where.snum = Dir[Playernum-1].snum;
	where.pnum = Dir[Playernum-1].pnum;

} else {

		/* they are surveying a sector */
	if (isdigit(args[1][0]) && index(args[1],',')!=NULL) {
		if (Dir[Playernum-1].level!=LEVEL_PLAN) {
			sprintf(buf,"There are no sectors here.\n");
			notify(Playernum, buf);
			return;
		} else {
			where.level = LEVEL_PLAN;
			where.snum = Dir[Playernum-1].snum;
			where.pnum = Dir[Playernum-1].pnum;
		}
	} else {
		where = Getplace(Playernum,args[1],0);
		if (where.err)
			return;
	}

}

free(Race);
openracedata(&survey_racedata);
getrace(survey_racedata, &Race, Playernum);
close_file(survey_racedata);

if (where.level==LEVEL_PLAN) {


  openpdata(&survey_pdata);
  getplanet(survey_pdata,&p,Stars[where.snum]->planetpos[where.pnum]);
  close_file(survey_pdata);

  compat = compatibility(p,Race);


  if (isdigit(args[1][0]) && index(args[1],',')!=NULL) {

	opensectdata(&survey_sectdata);
	getsmap(survey_sectdata,Smap,p);
	close_file(survey_sectdata);

	get4args(args[1],&x2,&hix,&lowy,&hiy); 
			/* ^^^ translate from lowx:hix,lowy:hiy */
	x2 = MAX(0, x2);
	hix = MIN(hix, p->Maxx-1);
	lowy = MAX(0, lowy);
	hiy = MIN(hiy, p->Maxy-1);

	sprintf(buf," x,y des (    type   )  owner eff mob frt res popn ^popn\n");
			notify(Playernum, buf);

	for (; lowy<=hiy; lowy++)
	 	for (lowx=x2; lowx<=hix; lowx++) {
	  		s = &Sector(*p, lowx, lowy);
	  		/*if (s->owner==Playernum)*/
		sprintf(buf,"%2d,%-2d ", lowx, lowy);
			notify(Playernum, buf);
		if ( (d = desshow(Playernum, p, lowx, lowy, Race))==CHAR_CLOAKED) {
			 sprintf(buf,"?  (     ?     )\n");
			notify(Playernum, buf);
			} else {
	     		   sprintf(buf,"%c  (%11s) %6u%4u%4u%4u%4u%5u%6d\n",
			d, Desnames[s->des], s->owner, s->eff,
			s->mobilization, s->fert, s->resource, s->popn,
			maxsupport(Race,s,compat,p->conditions[TOXIC]) );
			notify(Playernum, buf);
		}
 	}
	free(p);

  } else {

		/* survey of planet */

	sprintf(buf,"%s:\n",Stars[where.snum]->pnames[where.pnum]);
			notify(Playernum, buf);
	sprintf(buf,"gravity   x,y absolute     x,y relative to %s\n",Stars[where.snum]->name);
			notify(Playernum, buf);
	sprintf(buf,"%7.2f   %7.1f,%7.1f   %8.1f,%8.1f\n", 
		gravity(p),
		p->xpos + Stars[where.snum]->xpos,
		p->ypos + Stars[where.snum]->ypos,
		p->xpos, p->ypos );

			notify(Playernum, buf);
	sprintf(buf,"======== Planetary conditions: ========\n");
			notify(Playernum, buf);
	sprintf(buf,"atmosphere concentrations:\n");
			notify(Playernum, buf);
	sprintf(buf,"     methane %02d%%(%02d%%)     oxygen %02d%%(%02d%%)\n",
		p->conditions[METHANE], Race->conditions[METHANE],
		p->conditions[OXYGEN], Race->conditions[OXYGEN] );
			notify(Playernum, buf);
	sprintf(buf,"         CO2 %02d%%(%02d%%)   hydrogen %02d%%(%02d%%)      temperature: %3d (%3d)\n",
		p->conditions[CO2], Race->conditions[CO2],
		p->conditions[HYDROGEN], Race->conditions[HYDROGEN],
		Temp(p->conditions[TEMP]), Temp(Race->conditions[TEMP]) );
			notify(Playernum, buf);
	sprintf(buf,"    nitrogen %02d%%(%02d%%)     sulfur %02d%%(%02d%%)           normal: %3d\n",
		p->conditions[NITROGEN], Race->conditions[NITROGEN],
		p->conditions[SULFUR], Race->conditions[SULFUR],
		Temp(p->conditions[RTEMP]) );
			notify(Playernum, buf);
	sprintf(buf,"      helium %02d%%(%02d%%)      other %02d%%(%02d%%)\n",
		p->conditions[HELIUM], Race->conditions[HELIUM],
		p->conditions[OTHER], Race->conditions[OTHER]);
			notify(Playernum, buf);
	if ((tindex = p->conditions[TOXIC]/10) < 0)
		tindex = 0;
	else if (tindex > 10)
		tindex = 11;
	sprintf(buf,"                     Toxicity: %d%% (%s)\n", 
		p->conditions[TOXIC], Tox[tindex] );
			notify(Playernum, buf);
	sprintf(buf,"Total planetary compatibility: %.2f%%\n", compatibility(p, Race) );
			notify(Playernum, buf);

	sprintf(buf,"fuel_stock  resource_stock dest_pot.   %s    ^%s\n",
		Race->Thing ? "biomass" : "popltn",
		Race->Thing ? "biomass" : "popltn");
			notify(Playernum, buf);
	sprintf(buf,"%10lu  %14lu %9lu  %7lu%11lu\n", p->info[Playernum-1].fuel, 
		 p->info[Playernum-1].resource, 
		 p->info[Playernum-1].destruct,
		 p->popn, p->maxpopn);
			notify(Playernum, buf);
	if (p->slaved_to) {
		sprintf(buf,"This planet ENSLAVED to player %d!\n", p->slaved_to);
			notify(Playernum, buf);
		}
	free(p);

  }

 } else if (where.level==LEVEL_STAR) {

  sprintf(buf,"Star %s\n",Stars[where.snum]->name);
			notify(Playernum, buf);
  sprintf(buf,"locn: %f,%f\n",Stars[where.snum]->xpos,Stars[where.snum]->ypos);
			notify(Playernum, buf);
  sprintf(buf,"gravity: %.2f\tstability: ", Stars[where.snum]->gravity);
			notify(Playernum, buf);
  sprintf(buf,"temperature class (1->10) %d\n", Stars[where.snum]->temperature);
		notify(Playernum, buf);  
if (Race->tech >= TECH_SEE_STABILITY) {
  	sprintf(buf,"%d%% (%s)\n",
		Stars[where.snum]->stability, 
		Stars[where.snum]->stability<20 ? "stable" :
		Stars[where.snum]->stability<40 ? "unstable" : 
		Stars[where.snum]->stability<60 ? "dangerous" : 
		Stars[where.snum]->stability<100 ? "WARNING! nova iminent!" : 
		"undergoing nova" );
			notify(Playernum, buf);
  } else {
	sprintf(buf,"(cannot determine)\n");
			notify(Playernum, buf);
	}
  sprintf(buf,"%d planets are ",Stars[where.snum]->numplanets);
			notify(Playernum, buf);
  for (x2=0; x2<Stars[where.snum]->numplanets; x2++) {
	sprintf(buf,"%s ", Stars[where.snum]->pnames[x2]);
			notify(Playernum, buf);
	}
  sprintf(buf,"\n");
			notify(Playernum, buf);

 } else if (where.level==LEVEL_UNIV) {
  sprintf(buf,"It's just _there_, you know?\n");
			notify(Playernum, buf);

} else {
	sprintf(buf,"scope must be a planet.\n");
			notify(Playernum, buf);
	}
}
